<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Block\Adminhtml\Category\Edit;

use Exception;
use Magento\Backend\Block\Widget\Tabs as WidgetTabs;
use Magento\Framework\Exception\LocalizedException;

class Tabs extends WidgetTabs
{
    /**
     * @return void
     */
    protected function _construct()
    {
        parent::_construct();

        $this->setId('category_tabs');
        $this->setDestElementId('edit_form');
        $this->setTitle(__('Category Information'));
    }

    /**
     * @return $this
     * @throws Exception
     * @throws LocalizedException
     */
    protected function _prepareLayout()
    {
        parent::_prepareLayout();

        $this->addTabAfter('images', [
            'label' => __('Images'),
            'url' => $this->getUrl('*/*/images', ['_current' => true]),
            'class' => 'ajax'
        ], 'main');
        $this->addTabAfter('product', [
            'label' => __('Products'),
            'url' => $this->getUrl('*/*/products', ['_current' => true]),
            'class' => 'ajax'
        ], 'main');

        return $this;
    }
}
