<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 *
 */

namespace Milople\Personalizedrich\Block;

use Magento\Catalog\Model\ProductRepository;
use Magento\Catalog\Model\ProductTypes\ConfigInterface;
use Magento\Framework\Registry;
use Magento\Framework\View\Element\Template;
use Magento\Store\Model\ScopeInterface;

class Personalized extends Template
{
    protected $_coreRegistry = null;
    protected $_registry;
    protected $_productRepository;

    public function __construct(
        Template\Context  $context,
        ProductRepository $productRepository,
        ConfigInterface   $productTypeConfig,
        Registry          $registry,
        array             $data = []
    )
    {
        $this->_productRepository = $productRepository;
        $this->productTypeConfig = $productTypeConfig;
        $this->_registry = $registry;
        parent::__construct($context, $data);
    }

    public function getCurrentProduct()
    {
        return $this->_registry->registry('current_product');
    }

    public function getProductById($id)
    {
        return $this->_productRepository->getById($id);
    }

    public function shouldRenderQuantity()
    {
        $p_id = $this->getRequest()->getParam('id');
        $_product = $this->_productRepository->getById($p_id);
        return !$this->productTypeConfig->isProductSet($_product->getTypeId());
    }

    public function isRedirectToCartEnabled()
    {
        return $this->_scopeConfig->getValue('checkout/cart/redirect_to_cart', ScopeInterface::SCOPE_STORE);
    }
}
