<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Controller\Adminhtml\Index;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Backend\Model\View\Result\Page;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Exception;
use Magento\Framework\Filesystem\Io\File;
use Magento\Framework\View\Result\PageFactory;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use ZIPARCHIVE;

class Rawdownload extends Action
{

    protected $_publicActions = ['rawdownload'];

    /**
     * @var PageFactory
     */
    protected $resultPageFactory;
    protected $filesystem;
    protected $personalized_helper;
    protected $directory_list;

    /**
     * @param Context $context
     * @param PageFactory $resultPageFactory
     */
    public function __construct(
        Context       $context,
        PageFactory   $resultPageFactory,
        File          $filesystem,
        Personalized  $personalized_helper,
        DirectoryList $directory_list
    )
    {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
        $this->filesystem = $filesystem;
        $this->personalized_helper = $personalized_helper;
        $this->directory_list = $directory_list;
    }

    /**
     * Index action
     *
     * @return Page
     */
    public function execute()
    {

        $customDir = $this->directory_list->getPath('media') . '/personalized/uploads/';
        $file_arr = [];
        $files = explode(',', $this->getRequest()->getParam('names'));
        foreach ($files as $file) {
            $file_arr[] = $customDir . $file;
        }
        if (count($file_arr) > 0) {
            $result = $this->personalized_helper->create_zip("milople_raw_personalized_products.zip" ,$file_arr);
        }
    }

    /**
     * Is the user allowed to view the fonts grid.
     *
     * @return bool
     */
    protected function _isAllowed()
    {
        return true;
    }
}
