<?php
/**
*
* Do not edit or add to this file if you wish to upgrade the module to newer
* versions in the future. If you wish to customize the module for your
* needs please contact us to https://www.milople.com/contact-us.html
*
* @category    Ecommerce
* @package     Milople_Personlized
* @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
* @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
*
**/
namespace Milople\Personalizedrich\Controller\Adminhtml\Index;

use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use Magento\Framework\Exception;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Downloadpdf extends \Magento\Backend\App\Action
{
    
    protected $_publicActions = ['downloadpdf'];

    /**
     * @var PageFactory
     */
    protected $resultPageFactory;
 
    /**
     * @param Context $context
     * @param PageFactory $resultPageFactory
     */
    public function __construct(
        Context $context,
        PageFactory $resultPageFactory,
        \Magento\Framework\Filesystem\Io\File $filesystem,
        \Magento\Framework\App\Response\Http\FileFactory $fileFactory,
        \Magento\Framework\App\Filesystem\DirectoryList $directory_list
    ) {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
        $this->filesystem=$filesystem;
        $this->fileFactory = $fileFactory;
        $this->directory_list= $directory_list;
    }

    /**
     * Index action
     *
     * @return \Magento\Backend\Model\View\Result\Page
     */
    public function execute()
    {
        $customDir = $this->directory_list->getPath('media').'/personalized/images/';
                $file_arr=array();
        $files = explode(',', $this->getRequest()->getParam('names'));
        foreach ($files as $file) {
            $file_arr[]= $customDir.$file;
        }
        if (count($file_arr)>0) {
            $result = $this->create_pdf("milople_personalized_products.pdf" ,$file_arr);
        }
    }

    public function create_pdf($destination ,$files = array())
    {

         $valid_files = array();
         $overwrite = false;
        /*if files were passed in...*/
        if(is_array($files)) {
            /*cycle through each file*/
            foreach($files as $file) {
                /*make sure the file exists*/
              
                if(file_exists($file)) {
                    $valid_files[] = $file;
                }
            }
        }
        if(count($valid_files)) {

            $pdf = new \Zend_Pdf();
            $i = 0;
            foreach($valid_files as $file) {
                $image = \Zend_Pdf_Image::imageWithPath($file);
                $imgWidthPts  = $image->getPixelWidth();
                $imgHeightPts = $image->getPixelHeight();
                $imagesizevariable = $imgWidthPts.':'.$imgHeightPts;
                $pdf->pages[] = $pdf->newPage($imagesizevariable);
                $page = $pdf->pages[$i];  /*this will get reference to the first page.*/
                $page->drawImage($image, 0, 0, $image->getPixelWidth(), $image->getPixelHeight());
                $i++;
            }
     
        $fileName = $destination;

        $this->fileFactory->create(
           $fileName,
           $pdf->render(),
           \Magento\Framework\App\Filesystem\DirectoryList::VAR_DIR,  /*this pdf will be saved in var directory with the name example.pdf*/
           'application/pdf'
        );

          }
    }

function pointsToMm( $points )
{
    return $points / 72 * 25.4;
}

function mmToPoints( $mm )
{
    return $mm / 25.4 * 72;
}
}