<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalizedrich-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Controller\Adminhtml\Quote;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Backend\Model\View\Result\Page;
use Magento\Framework\View\Result\PageFactory;

class Index extends Action
{


    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    /**
     * @param Context $context
     * @param PageFactory $resultPageFactory
     */
    public function __construct(
        Context     $context,
        PageFactory $resultPageFactory
    )
    {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
    }

    /**
     * Index action
     *
     * @return Page
     */
    public function execute()
    {

        /** @var Page $resultPage */
        $resultPage = $this->resultPageFactory->create();
        $resultPage->setActiveMenu('Milople_Personalizedrich::quote');
        $resultPage->addBreadcrumb(__('Quote'), __('Quote'));
        $resultPage->addBreadcrumb(__('Manage Quote'), __('Manage Quote'));
        $resultPage->getConfig()->getTitle()->prepend(__('Manage Quote'));

        return $resultPage;
    }

    /**
     * Is the user allowed to view the fonts grid.
     *
     * @return bool
     */
    protected function _isAllowed()
    {
        return true;
    }
}
