<?php

/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalizedrich-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Controller\Adminhtml\Quote;

use Exception;
use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Milople\Personalizedrich\Model\QuoteFactory;
use Webkul\Grid\Model\GridFactory;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Save extends Action
{
    /**
     * @var GridFactory
     */
    var $quoteFactory;

    /**
     * @param Context $context
     * @param GridFactory $gridFactory
     */
    public function __construct(
        Context      $context,
        QuoteFactory $quoteFactory
    )
    {
        parent::__construct($context);
        $this->quoteFactory = $quoteFactory;
    }

    /**
     * @SuppressWarnings(PHPMD.CyclomaticComplexity)
     * @SuppressWarnings(PHPMD.NPathComplexity)
     */
    public function execute()
    {
        $data = $this->getRequest()->getPostValue();
        if (!$data) {
            $this->_redirect('*/*/edit');
            return;
        }
        try {
            $rowData = $this->quoteFactory->create();
            $rowData->setData($data);
            if (isset($data['id'])) {
                $rowData->setQuoteId($data['id']);
            }
            $rowData->save();
            $this->messageManager->addSuccess(__('Quote has been saved successfully.'));
        } catch (Exception $e) {
            $this->messageManager->addError(__($e->getMessage()));
        }
        $this->_redirect('*/*/');
    }

    /**
     * @return bool
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Milople_Personalizedrich::save');
    }
}
