<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Controller\Adminhtml\Quotecategory;

use Exception;
use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use Milople\Personalizedrich\Model\Quotecategory;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Delete extends Action
{
    public function __construct(
        Context       $context,
        Quotecategory $quoteCategory
    )
    {
        parent::__construct($context);
        $this->quotecategory = $quoteCategory;
    }

    /**
     * @var PageFactory
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        try {
            $banner = $this->quotecategory->load($id);
            $banner->delete();
            $this->messageManager->addSuccess(
                __('Deleted successfully !')
            );
        } catch (Exception $e) {
            $this->messageManager->addError($e->getMessage());
        }
        $this->_redirect('*/*/');
    }
}
