<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalizedrich-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Controller\Adminhtml\Quotecategory;

use Exception;
use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Backend\Model\Session;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Filesystem;
use Magento\MediaStorage\Model\File\UploaderFactory;
use Milople\Personalizedrich\Model\Quotecategory;
use RuntimeException;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Save extends Action
{

    protected $_fileUploaderFactory;

    public function __construct(
        Context         $context,
        Filesystem      $filesystem,
        Quotecategory   $quoteCategory,
        Session         $session,
        UploaderFactory $fileUploaderFactory
    )
    {
        $this->filesystem = $filesystem;
        $this->session = $session;
        $this->quotecategory = $quoteCategory;
        $this->_fileUploaderFactory = $fileUploaderFactory;
        parent::__construct($context);
    }

    public function execute()
    {
        $data = $this->getRequest()->getParams();
        if ($data) {
            $model = $this->quotecategory;

            $id = $this->getRequest()->getParam('category_id');
            if ($id) {
                $model->load($id);
            }

            $model->setName($data['name']);
            $model->setStatus($data['status']);

            try {
                $model->save();
                $this->messageManager->addSuccess(__('Category was saved successfully'));
                $this->session->setFormData(false);
                if ($this->getRequest()->getParam('back')) {
                    $this->_redirect('*/*/edit', ['id' => $model->getId(), '_current' => true]);
                    return;
                }
                $this->_redirect('*/*/');
                return;
            } catch (\Magento\Framework\Model\Exception $e) {
                $this->messageManager->addError($e->getMessage());
            } catch (RuntimeException $e) {
                $this->messageManager->addError($e->getMessage());
            } catch (Exception $e) {
                $this->messageManager->addException($e, __('Something went wrong while saving the category.'));
            }

            $this->_getSession()->setFormData($data);
            $this->_redirect('*/*/edit', ['category_id' => $this->getRequest()->getParam('category_id')]);
            return;
        }
        $this->_redirect('*/*/');
    }
}
