<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products.html
 *
 *
 */

namespace Milople\Personalizedrich\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filesystem\Io\File;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Milople\Personalizedrich\Model\AreaFactory;
use Milople\Personalizedrich\Model\Templateimage;
use Psr\Log\LoggerInterface;

class Copytemplates extends Action
{
    public function __construct(
        Context                                  $context,
        File                                     $filesystem,
        DirectoryList                            $directory_list,
        JsonFactory                              $resultJsonFactory,
        \Milople\Personalizedrich\Model\Template $templateFactory,
        Templateimage                            $templateImageFactory,
        AreaFactory                              $areaFactory,
        Personalized                             $helper,
        LoggerInterface                          $logger
    )
    {
        $this->_request = $context->getRequest();
        $this->filesystem = $filesystem;
        $this->directory_list = $directory_list;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        $this->templateFactory = $templateFactory;
        $this->templateImageFactory = $templateImageFactory;
        $this->areaFactory = $areaFactory;
        $this->helper = $helper;
        $this->resultJsonFactory = $resultJsonFactory;
        return parent::__construct($context);
    }

    public function execute()
    {
        $result = $this->resultJsonFactory->create();
        $postdata = $this->_request->getPost();
        $imageId = $postdata['imageId'];
        $productId = $postdata['productId'];
        $templateNameArray = $postdata['templatename'];
        $newtemplateNameArray = [];
        $index = 0;
        foreach ($templateNameArray as $templateName) {
            $newtemplateName = uniqid("template_copy_");
            /*Getting Template Text Objects*/
            $templateTextModel = $this->templateFactory;
            $tempalteCollection = $templateTextModel->getCollection()->addFieldToFilter('template_name', ['eq' => $templateName]);
            foreach ($tempalteCollection as $template) {
                $templateTextModel->setData(
                    [
                        'image_id' => $imageId,
                        'product_id' => $productId,
                        'template_name' => $newtemplateName,
                        'name' => $template->getName(),
                        'top' => $template->getTop(),
                        'left' => $template->getLeft(),
                        'angle' => $template->getAngle(),
                        'font_size' => $template->getFontSize(),
                        'font_family' => $template->getFontFamily(),
                        'font_color' => $template->getFontColor(),
                        'width' => $template->getWidth(),
                        'height' => $template->getHeight(),
                        'effect' => $template->getEffect(),
                        'curved_radius' => $template->getCurvedRadius(),
                        'curved_spacing' => $template->getCurvedSpacing(),
                        'curved_reverse' => $template->getCurvedRadius(),
                        'max_character' => $template->getMaxCharacter(),
                        'is_bold' => $template->getIsBold(),
                        'is_italic' => $template->getIsItalic(),
                        'is_underline' => $template->getIsUnderline(),
                        'text_align' => $template->getTextAlign()
                    ]
                );
                $templateTextModel->save();
            }
            /*Getting Template Image Objects*/
            $templateImageModel = $this->templateImageFactory;
            $templateImageCollection = $templateImageModel->getCollection()->addFieldToFilter('template_name', ['eq' => $templateName]);
            foreach ($templateImageCollection as $imagetemplate) {
                $templateImageModel->setData(
                    [
                        'image_id' => $imageId,
                        'product_id' => $productId,
                        'template_name' => $newtemplateName,
                        'name' => $imagetemplate->getName(),
                        'top' => $imagetemplate->getTop(),
                        'left' => $imagetemplate->getLeft(),
                        'angle' => $imagetemplate->getAngle(),
                        'width' => $imagetemplate->getWidth(),
                        'height' => $imagetemplate->getHeight()
                    ]
                );
                $templateImageModel->save();
            }
            $areaModel = $this->areaFactory->create();
            $areaCollection = $areaModel->getCollection()->addFieldToFilter('template_name', ['eq' => $templateName]);
            foreach ($areaCollection as $area) {
                $areaModel->setData(
                    [
                        'image_id' => $imageId,
                        'product_id' => $productId,
                        'template_name' => $newtemplateName,
                        'template_checked' => "notchecked",
                        'x1' => $area->getdata('x1'),
                        'y1' => $area->getdata('y1'),
                        'x2' => $area->getdata('x2'),
                        'y2' => $area->getdata('y2'),
                        'width' => $area->getWidth(),
                        'height' => $area->getHeight()
                    ]
                );
                $areaModel->save();
                $newtemplateNameArray[$index] = $newtemplateName;
            }
            $index++;
        }
        $result->setData(['newtemplateNameArray' => $newtemplateNameArray]);
        return $result;
    }
}
