<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products.html
 *
 *
 */

namespace Milople\Personalizedrich\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filesystem\Io\File;
use Milople\Personalizedrich\Model\Area;
use Milople\Personalizedrich\Model\Templateimage;
use Psr\Log\LoggerInterface;

class Delete extends Action
{
    public function __construct(
        Context                                  $context,
        File                                     $filesystem,
        DirectoryList                            $directory_list,
        JsonFactory                              $resultJsonFactory,
        Area                                     $areaFactory,
        \Milople\Personalizedrich\Model\Template $templateFactory,
        Templateimage                            $templateImageFactory,
        LoggerInterface                          $logger
    )
    {
        $this->_request = $context->getRequest();
        $this->filesystem = $filesystem;
        $this->directory_list = $directory_list;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        $this->templateFactory = $templateFactory;
        $this->templateImageFactory = $templateImageFactory;
        $this->areaFactory = $areaFactory;
        return parent::__construct($context);
    }

    public function execute()
    {
        $postdata = $this->_request->getPost();
        $imageId = $postdata['imageId'];
        $productId = $postdata['productId'];
        $checkboxChecked = $postdata['checkboxChecked'];
        for ($i = 0; $i < sizeof($checkboxChecked); $i++) {
            $model = $this->templateFactory;
            $templateCollection = $model->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->addFieldToFilter('product_id', ['eq' => $productId])->addFieldToFilter('template_name', ['eq' => $checkboxChecked[$i]])->walk('delete');
            $model = $this->templateImageFactory;
            $templateImageCollection = $model->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->addFieldToFilter('product_id', ['eq' => $productId])->addFieldToFilter('template_name', ['eq' => $checkboxChecked[$i]])->walk('delete');
            $model = $this->areaFactory;
            $areaCollection = $model->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->addFieldToFilter('product_id', ['eq' => $productId])->addFieldToFilter('template_name', ['eq' => $checkboxChecked[$i]])->walk('delete');
        }
    }
}
