<?php
/**
*
* Do not edit or add to this file if you wish to upgrade the module to newer
* versions in the future. If you wish to customize the module for your
* needs please contact us to https://www.milople.com/contact-us.html
*
* @category    Ecommerce
* @package     Milople_Personlized
* @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
* @url         https://www.milople.com/magento2-extensions/personalized-products.html
*
**/
namespace Milople\Personalizedrich\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Controller\Result\JsonFactory;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Filesystem\Io\File;
use Psr\Log\LoggerInterface;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Index extends Action
{
    public function __construct(
    	Context         $context,
        File            $filesystem,
        DirectoryList   $directory_list,
        Personalized    $helper,
        JsonFactory     $resultJsonFactory,
        LoggerInterface $logger
    ) {
        
        $this->_request = $context->getRequest();
        $this->filesystem=$filesystem;
        $this->directory_list= $directory_list;
        $this->helper=$helper;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        return parent::__construct($context);

    }
     
    public function execute()
    {
    	$isGlobalImgAllowed=$this->helper->getConfig('personalizedrich/general_setting_group/enable_img');
    	   
    	$postdata = $this->_request->getPost();
	  	$fileName=array();
	  	$content= $postdata['imagedata'];
		   
		$count=0;

		  
	   	if ($isGlobalImgAllowed == 1) {
	   	
           foreach ($content as  $data) {
			/*code for creation images...*/
				if($data!='blank'){
				   $fileName[]= uniqid() . '.svg';
				   $imageUrl = $this->directory_list->getPath('media').'/personalized/images/';
				   $result = $this->filesystem->checkAndCreateFolder($imageUrl);
				   $file= $imageUrl.$fileName[$count];
				   $success = $this->filesystem->write($file, $data);
				   $count++;
				}
				else
				{
				   $fileName[]="blank";
				}
		 	}		   	
	   	}else{
	   	
        	foreach ($content as  $data) {
			/*code for creation images...*/
				if($data!='blank'){
				   $data = str_replace('data:image/png;base64,', '', $data);
				   $data = str_replace(' ', '+', $data);
				   $data = base64_decode($data);
				   $fileName[]= uniqid() . '.png';
				   $imageUrl = $this->directory_list->getPath('media').'/personalized/images/';
				   $result = $this->filesystem->checkAndCreateFolder($imageUrl);
				   $file= $imageUrl.$fileName[$count];
				   $success = $this->filesystem->write($file, $data);
				   $count++;
				}
				else
				{
				   $fileName[]="blank";
				}
		 	}
	   	}
		 
		 
		$returnValue=implode(",",$fileName);
		$resultJson = $this->resultFactory->create(ResultFactory::TYPE_JSON);
        $resultJson->setData($returnValue);
        return $resultJson;
		 
    }
}
