<?php
/**
*
* Do not edit or add to this file if you wish to upgrade the module to newer
* versions in the future. If you wish to customize the module for your
* needs please contact us to https://www.milople.com/contact-us.html
*
* @category    Ecommerce
* @package     Milople_Personlized
* @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
* @url         https://www.milople.com/magento2-extensions/personalized-products.html
*
**/
namespace Milople\Personalizedrich\Controller\Index;

use Magento\Catalog\Helper\Image;
use Magento\Catalog\Model\Product;
use Magento\Catalog\Model\ProductFactory;
use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filesystem\Io\File;
use Magento\Framework\View\Asset\Repository;
use Magento\Swatches\Helper\Data;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Psr\Log\LoggerInterface;

class Load extends Action
{
    protected $templateFactory;

    public function __construct(
        Context                                  $context,
        File                                     $filesystem,
        ProductFactory                           $productModelFactory,
        DirectoryList                            $directory_list,
        JsonFactory                              $resultJsonFactory,
        ScopeConfigInterface                     $scopeConfig,
        \Milople\Personalizedrich\Model\Template $templateFactory,
        Data                                     $swatchHelper,
        Image                                    $imageHelper,
        Personalized                             $personalizedHelper,
        Repository                               $assetRepo,
        LoggerInterface                          $logger
    )
    {
        $this->_request = $context->getRequest();
        $this->filesystem = $filesystem;
        $this->directory_list = $directory_list;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        $this->swatchHelper = $swatchHelper;
        $this->productModelFactory = $productModelFactory;
        $this->_scopeConfig = $scopeConfig;
        $this->templateFactory = $templateFactory;
        $this->imageHelper = $imageHelper;
        $this->personalizedHelper = $personalizedHelper;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_assetRepo = $assetRepo;
        return parent::__construct($context);
    }
     
    public function execute()
    {

        $count=1; 
        $i=0;
        $result = $this->resultJsonFactory->create();
        if ($productId = (int)$this->getRequest()->getParam('product_id')) {
            $currentConfigurable = $this->productModelFactory->create()->load($productId);
            $attributes = (array)$this->getRequest()->getParam('attributes');
            if (!empty($attributes)) {
                $product = $this->getProductVariationWithMedia($currentConfigurable, $attributes);
            }
            if ((empty($product) || (!$product->getImage() || $product->getImage() == 'no_selection'))
                && isset($currentConfigurable)
            ) {
                $product = $currentConfigurable;
            }
        }
            $productId = $product->getId();
            $model= $this->templateFactory;
        /*Getting Template*/
        $tempalteCollection=$model->getCollection()
                            ->addFieldToFilter('product_id',array('eq' => $productId)); 
        $sideCount =$this->personalizedHelper->getSideCount($product);
        foreach($product->getMediaGalleryImages() as $_image){
            $array[] = $_image;
        }
        $productprice = $product->getFinalPrice();


$sidehtml = "";
$isGlobalRestrictedAllowed = $this->personalizedHelper->getConfig('personalizedrich/general_setting_group/enable_area');
$isProductHasSide = $this->personalizedHelper->isProductHasSide($product);
$width = $this->personalizedHelper->getConfig('personalizedrich/area_setting_group/width');
$height = $this->personalizedHelper->getConfig('personalizedrich/area_setting_group/height');
$product_image_name_number = $product->getProductAllowNameNumber();

$imagehtml = '';

if($sideCount <= 1) {
    $imagehtml .='<input type="hidden" name="image_html"  id="image_html" value="" data-main-canvas-id="'.$array[0]->getId().'" data-main-image-src="'. $_image->getUrl() .'" data-main-template-count="'.$this->personalizedHelper->getCheckedTemplateCount($array[0]->getId(), $product->getId()) .'"/>';
}else{
      $i = 0;
          foreach ($product->getMediaGalleryImages() as $_image) {
                  if($this->personalizedHelper->isImageHasArea($product->getId(),$_image->getId())=="allowed"){

      $imagehtml .='<input type="hidden" name="image_html[]" id="image-'.$_image->getId().'" value="" data-main-image-src="'.$_image->getUrl().'" data-main-template-count="'.$this->personalizedHelper->getCheckedTemplateCount($_image->getId(), $product->getId()) .'"/>';
                  }
                  $i++;
                }
}


if ($isGlobalRestrictedAllowed == 1): 
  
            if($isProductHasSide) { 
$sidehtml .='<h4 id="personalized-options">Choose Side</h4><ul class="product-thumbs">';
            $i=0;
            foreach ($product->getMediaGalleryImages()  as $image) {
            if($this->personalizedHelper->isImageHasArea($product->getId(),$image->getId())=="allowed"){
            $imageUrl = $image->getUrl();
$sidehtml .= '<li>';
              if($product_image_name_number == 'no_selection'):
                  if($array[0]->getFile() == $image->getFile()):
$sidehtml .= '<a data-name-number="true"  data-main-image-src="'. $imageUrl .'" data-main-canvas-id="'. $image->getId().'"  ><img src="'.$imageUrl.'" sort-order="0" title="" style="width:50px; height:60px;cursor:pointer;"   /></a>';
                  else:
$sidehtml .= '<a data-name-number="false"  data-main-image-src="'. $imageUrl .'" data-main-canvas-id="'.$image->getId() .'"  ><img src="'.$imageUrl .'" sort-order="0" title="" style="width:50px; height:60px;cursor:pointer;"   /></a>';
                  endif; 
                else: 
                 if($product_image_name_number == $image->getFile()):
$sidehtml .= '<a data-name-number="true"  data-main-image-src="'.$imageUrl.'" data-main-canvas-id="'.$image->getId() .'"  ><img src="'.$imageUrl .'" sort-order="0" title="" style="width:50px; height:60px;cursor:pointer;"   /></a>';
                 else: 
$sidehtml .=  '<a data-name-number="false" data-main-image-src="'.$imageUrl.'" data-main-canvas-id="'.$image->getId().'"  ><img src="'.$imageUrl .'" sort-order="0" title="" style="width:50px; height:60px;cursor:pointer;"   /></a>';
                 endif;
              endif;
$sidehtml .=    '</li>';
                } $i++; }/*Foreach */
$sidehtml .= '</ul>';
    } /*IF */

endif ;
$isRestrictedAreaDrawn=$this->personalizedHelper->isRestrictedAreaDrawn($product);
$isGlobalRestrictedAllowed=$this->personalizedHelper->getConfig('personalizedrich/general_setting_group/enable_area');


        if (!$isRestrictedAreaDrawn || !$isGlobalRestrictedAllowed) {
        
        $flag1 =array();
        $width1 =array();
        $height1 =array();
        $flagForHide1 =array();
        $getoriginalwidth = array();
        $getoriginalheight = array();
        $base=$this->personalizedHelper->getBaseImage($productId,$this->imageHelper);
        $imageId=$base['id'];
        $imageUrl=$base['url'];

          $area = "";
          $area .= '<div id="no-area"><div id="container"><canvas id="imageCanvas" class="canvas"></canvas> </div><div id="product-zoom-container" style="display: none;"><canvas id="product-zoom-canvas" width="'.$width.'" height="'.$height.'"></canvas></div></div>';        
            $noarea=1;
        }else{
          $area = "";
        $flag="not allowed";
        $flagForHide="hide";
        $imageId = array();
        $imageUrl = array();
        $flag1 =array();
        $width1 =array();
        $height1 =array();
        $flagForHide1 =array();
        $getoriginalwidth = array();
        $getoriginalheight = array();        
              $i=0;
          foreach ($product->getMediaGalleryImages() as $image) : 
              if($flag=="not allowed"){
                $flag = $this->personalizedHelper->isImageHasArea($product->getId(),$image->getId());
                if($flag=="allowed" ){
                   $flagForHide='show';
                  }
                }
           

          if($this->personalizedHelper->isImageHasArea($product->getId(),$image->getId())=='allowed'){ 
              
             array_push($flag1, $flag);
             array_push($width1, $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Width'));
             array_push($height1, $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Height'));
             $width_data = $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Width');
             $height_data = $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Height');
             array_push($flagForHide1, $flagForHide);
             array_push($imageId, $image->getId());
             array_push($getoriginalwidth, $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Width'));
             array_push($getoriginalheight, $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Height'));
             if ($i == 0) {
                array_push($imageUrl, $this->personalizedHelper->resize($image->getFile(),$width,$height));
               $myarea = 'display:block; ';
              } else{ 
               $myarea = 'display:none; '; 
             }
             $dataPrice =  0;

             if ($this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Templateprice') != '') {
              $dataPrice = $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Templateprice');
             }
            $area .= '<div id="drawingArea-'.$image->getId().'" class="designAreasDiv" style="top: '.$this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Y1').'px;width:'.$width_data .'px;height:'.$this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Height') .'px; left: '.$this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'X1'). 'px;position: absolute;z-index: 10;border: 1px dashed;'.$myarea.'" data-image=" '.$image->getId() .'"><canvas id="imageCanvas-'.$image->getId().'" data-top="'. $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Y1') .'" data-left="'.$this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'X1') .'" data-width="'.$width_data .'" data-height="'. $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Height') .'" height="'. $this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Height') .'" width="'.$this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Width').'" height="'.$this->personalizedHelper->getCoordinates($product->getId(),$image->getId(),'Height') .'" data-price="'.$dataPrice.'" data-area-id="'.$image->getId().'" data-template-status="No" setDiscount="0" ></canvas> </div><div class="zoom-data-canvas" id="product-zoom-container-'.$image->getId().'" style="display: none;"><canvas id="product-zoom-canvas-'.$image->getId() .'" width="'.$width .'" height="'.$height.'"></canvas></div>';
            $area .= '</div>';
            
            $noarea=0;   
         }
        
          $count++; 
          $i++;
        endforeach;           
        }




        $html='';   
        foreach ($tempalteCollection as $template) 
            {
                $html.="<label class='label-template'>Name".$count."</label><input data-id='".$count."'' id='add_text_".$template->getId()."'type='text' class='template-text' placeholder='".$template->getName()."' data-size='".$template->getFontSize()."' data-family='".$template->getFontFamily()."' data-top='". $template->getTop() ."' data-left='".$template->getLeft()."' data-char='".$template->getMaxCharacter()."' maxlength='".$template->getMaxCharacter()."' data-angle='".$template->getAngle()."' data-effect='".$template->getEffect()."' data-radius='".$template->getCurvedRadius()."'  data-spacing='".$template->getCurvedSpacing()."' value='' />
                <div><span id='character-left". $count."' class='characters-left' ></span><span class='lblMaxLength'>Max Length ".$template->getMaxCharacter()."</span>
                </div>";
                $count++; 
            }

        $templatePreview = '';
        $flag = "not allowed";          
        $flagForHide = "hide";

        foreach ($product->getMediaGalleryImages()  as $image) {
            if($flag=="not allowed"){
                  $flag=$this->personalizedHelper->isImageHasArea($product->getId(),$image->getId());
                if($flag=="allowed" ){
                  $flagForHide='show';
                }
            }

             $blockclass = "display:block";  
        if($this->personalizedHelper->isImageHasArea($product->getId(),$image->getId()=="allowed")){
          $templateCollection=$this->personalizedHelper->getTemplateCollection($product,$image->getId());
          $templateImageCollection=$this->personalizedHelper->getTemplateImageCollection($product,$image->getId());
        if(count($templateCollection)>0 || count($templateImageCollection)>0){
        $templatePreview .= '<div id="image-template-'.$image->getId() .'" data-image-url="'.$image->getFile() .'" class="imageTemplate" style="'.$blockclass.'"><div id="home_div_'.$image->getId(). '" class="home" style="display:none;"><button type="button" title="Home" id="home"><img src="'.$this->_assetRepo->getUrl("Milople_Personalizedrich::images/gallery.png").'" /></button></div><div id="form_'.$image->getId().'"></div><input type="hidden" id="template_name" value="" style="display:none;" /><span class="a-center" id="template-loader" class="loader" style="display:none;"><img src="'.$this->_assetRepo->getUrl("Milople_Personalizedrich::images/ajax-loader.gif").'" class="v-middle" alt=""/></span></div>';
         } 
        } 
      }         


        $result->setData([
           'html'  => $html,
           'base'  => $imageUrl,
           'area'  => $area,
           'id'    => $imageId,
           'height1'    => $height1,
           'width1'    => $width1,
           'noarea' =>$noarea,
           'imagehtml' =>$imagehtml,
           'sidehtml' =>$sidehtml,
           'flag1' =>$flag1,
           'templatePreview'=>$templatePreview,
           'flagForHide1' =>$flagForHide1,
           'productchidid' =>$productId,
           'getoriginalwidth' =>$getoriginalwidth,
           'getoriginalheight' =>$getoriginalheight,
           'height'=>$height,
           'width'=>$width,
           'productprice' =>$productprice
         ]);    
       return $result; 
   }

    function getProductVariationWithMedia(Product $currentConfigurable, array $attributes)
    {
        $product = null;
        $layeredAttributes = [];
        $configurableAttributes = $this->swatchHelper->getAttributesFromConfigurable($currentConfigurable);
        if ($configurableAttributes) {
            $layeredAttributes = $this->getLayeredAttributesIfExists($configurableAttributes);
        }
        $resultAttributes = array_merge($layeredAttributes, $attributes);

        $product = $this->swatchHelper->loadVariationByFallback($currentConfigurable, $resultAttributes);
        if (!$product || (!$product->getImage() || $product->getImage() == 'no_selection')) {
            /*$product = $this->swatchHelper->loadFirstVariationWithSwatchImage($currentConfigurable, $resultAttributes);*/
        }
        if (!$product) {
            $product = $this->swatchHelper->loadFirstVariationWithImage($currentConfigurable, $resultAttributes);
        }
        return $product;
    }

    /**
     * @param array $configurableAttributes
     * @return array
     */
    protected function getLayeredAttributesIfExists(array $configurableAttributes)
    {
        $layeredAttributes = [];

        foreach ($configurableAttributes as $attribute) {
            if ($urlAdditional = (array)$this->getRequest()->getParam('additional')) {
                if (array_key_exists($attribute['attribute_code'], $urlAdditional)) {
                    $layeredAttributes[$attribute['attribute_code']] = $urlAdditional[$attribute['attribute_code']];
                }
            }
        }
        return $layeredAttributes;
    }
}
