<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products.html
 *
 *
 */

namespace Milople\Personalizedrich\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filesystem\Io\File;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Psr\Log\LoggerInterface;

class Quote extends Action
{

    public function __construct(
        Context         $context,
        File            $filesystem,
        DirectoryList   $directory_list,
        Personalized    $helperPersonalized,
        JsonFactory     $resultJsonFactory,
        LoggerInterface $logger
    )
    {
        $this->_request = $context->getRequest();
        $this->filesystem = $filesystem;
        $this->directory_list = $directory_list;
        $this->helperPersonalized = $helperPersonalized;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        return parent::__construct($context);
    }

    public function execute()
    {
        $postdata = $this->_request->getPost();
        $categoryId = $postdata['quote_cat_id'];
        $data = $this->helperPersonalized->getFilteredQuote($categoryId);
        if (empty($data)) {
            $data = __("Sorry, no quotes found.");
        }
        $returnData = $this->resultJsonFactory->create();
        return $returnData->setData(['quote' => $data]);
    }
}
