<?php
/**
*
* Do not edit or add to this file if you wish to upgrade the module to newer
* versions in the future. If you wish to customize the module for your
* needs please contact us to https://www.milople.com/contact-us.html
*
* @category    Ecommerce
* @package     Milople_Personlized
* @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
* @url         https://www.milople.com/magento2-extensions/personalized-products.html
*
**/

namespace Milople\Personalizedrich\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\MediaStorage\Model\File\UploaderFactory;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filesystem\Io\File;
use Milople\Personalizedrich\Model\Area;
use Milople\Personalizedrich\Model\Templateimage;
use Psr\Log\LoggerInterface;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Save extends Action
{

    public function __construct(
        Context                                  $context,
        File                                     $filesystem,
        DirectoryList                            $directory_list,
        UploaderFactory                          $fileUploaderFactory,
        JsonFactory                              $resultJsonFactory,
        \Milople\Personalizedrich\Model\Template $templateFactory,
        Templateimage                            $templateimageFactory,
        Area                                     $areaFactory,
        LoggerInterface                          $logger
    )
    {
        $this->_request = $context->getRequest();
        $this->filesystem = $filesystem;
        $this->directory_list = $directory_list;
        $this->_fileUploaderFactory = $fileUploaderFactory;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        $this->templateFactory = $templateFactory;
        $this->templateimageFactory = $templateimageFactory;
        $this->areaFactory = $areaFactory;
        return parent::__construct($context);
    }

    public function execute()
    {
        $result = $this->resultJsonFactory->create();
        $postdata = $this->_request->getPost();
        $imageId=$postdata['imageId'];
        $productId=$postdata['productId'];
        $count=$postdata['count'];
        $imagecount=$postdata['imagecount'];
        $character=$postdata['character'];
        $name=$postdata['name'];
        $top=$postdata['top'];
        $left=$postdata['left'];
        $angle=$postdata['angle'];
        $height=$postdata['height'];
        $width=$postdata['width'];
        $size=$postdata['size'];
        $family=$postdata['family'];
        $effect=$postdata['effect'];
        $radius=$postdata['radius'];
        $spacing=$postdata['spacing'];
        $reverse=$postdata['reverse'];
        $bold=$postdata['bold'];
        $italic=$postdata['italic'];
        $underline=$postdata['underline'];
        $fontColor=$postdata['font_color'];
        $textAlignment=$postdata['text_align'];
        $x1=$postdata['x1'];
        $x2=$postdata['x2'];
        $y1=$postdata['y1'];
        $y2=$postdata['y2'];
        $w=$postdata['w'];
        $h=$postdata['h'];
        $set=$postdata['set'];
        $checkboxNotChecked = $postdata['checkboxNotChecked'];
        $checkboxNotChecked = explode("," , $checkboxNotChecked);
        $checkboxChecked=$postdata['checkboxChecked'];
        $checkboxChecked = explode("," , $checkboxChecked);
        $existingtemplateName=$postdata['templatename'];
        $templateoverlay = $postdata['templateOverlay'];
        $newtemplateName = '';
        if ($existingtemplateName == '') {
          $newtemplateName=uniqid('template_');        
        }
        $imagename = $postdata['imagename'];
        $imageleft=$postdata['imageleft'];
        $imagetop=$postdata['imagetop'];
        $imageangle=$postdata['imageangle'];
        $imagewidth=$postdata['imagewidth'];
        $imageheight=$postdata['imageheight'];

        $imageposting=$postdata['imageposting'];       
        $defaultimageobject=$postdata['defaultimageobject'];       
        $files = $this->getRequest()->getFiles('filename');


        $is_ellipse=$postdata['canvas_type'];
        $textFlag = 0;
        if($set == "set" && $w !=0 && $h !=0){
        $templateTextModel= $this->templateFactory;
        $templateCollection = $templateTextModel->getCollection()
                ->addFieldToFilter('image_id', array('eq' => $imageId))
                ->addFieldToFilter('product_id',array('eq' => $productId));
        $templateNameCollection =$templateTextModel->getCollection()
                ->addFieldToFilter('image_id', array('eq' => $imageId))
                ->addFieldToFilter('product_id',array('eq' => $productId))
                ->addFieldToFilter('template_name',array('eq' => $existingtemplateName));
        if(is_array($existingtemplateName)&&count($existingtemplateName) == '' && is_array($name) && sizeof($name) !=0 ) // this is for new
        {
             /* Insert Data */
            for($i = 0; $i < $count; $i++)
            {
               $templateTextModel->setData(
                  array(
                  'image_id'=>$imageId,
                  'product_id'=>$productId,
                  'template_name'=>$newtemplateName,
                  'name' => $name[$i],
                   'top' => $top[$i],
                   'left' => $left[$i],
                   'angle' => $angle[$i],
                   'font_size' =>$size[$i],
                   'font_family'=>$family[$i],
                   'width'=>$width[$i],
                   'height'=>$height[$i],
                   'effect'=>$effect[$i],
                   'curved_radius'=>$radius[$i],
                   'curved_spacing'=>$spacing[$i],
                   'curved_reverse'=>$reverse[$i],
                   'max_character'=> $character[$i],
                   'is_bold'=> $bold[$i],
                   'is_italic'=> $italic[$i],
                   'is_underline'=>$underline[$i],
                   'font_color'=>$fontColor[$i],
                   'text_align'=>$textAlignment[$i]
                  ));
               
                  $templateTextModel->save();
           }

       }else{
         $i = 0;
         $isAvailable = 0;
         foreach($templateCollection as $modelTemplate)
         {
            if($modelTemplate->getTemplateName() == $existingtemplateName){
              $isAvailable = 1;
              $textFlag = 1;
              // Delete if image is not available
              if ($i >= $count) {
                 $templateCollection =$templateTextModel->getCollection()
                  ->addFieldToFilter('template_id',array('eq' => $modelTemplate->getTemplateId()))
                  ->walk('delete');

              } else {
                $templateTextModel->load($modelTemplate->getTemplateId());
                $templateTextModel->setData(
                    array(
                    'template_id' =>$modelTemplate->getTemplateId(),
                    'image_id'=>$modelTemplate->getImageId(),
                    'template_name'=>$modelTemplate->getTemplateName(),
                    'product_id'=>$modelTemplate->getProductId(),
                    'name' => $name[$i],
                    'top' => $top[$i],
                    'left' => $left[$i],
                    'angle' => $angle[$i],
                    'font_size' =>$size[$i],
                    'font_family'=>$family[$i],
                    'width'=>$width[$i],
                    'height'=>$height[$i],
                    'effect'=>$effect[$i],
                    'curved_radius'=>$radius[$i],
                    'curved_spacing'=>$spacing[$i],
                    'curved_reverse'=>$reverse[$i],
                    'max_character'=> $character[$i],
                    'is_bold'=> $bold[$i],
                    'is_italic'=> $italic[$i],
                    'is_underline'=>$underline[$i],
                    'font_color'=>$fontColor[$i],
                    'text_align'=>$textAlignment[$i]
                ));
                $templateTextModel->save();
              }
              $i++;
            }
        }
        if ($count > count($templateNameCollection) && $textFlag == 1)
              {
                for ($i=0; $i < $count; $i++)
                {
                  $templateTextModel->setData(
                  array(
                  'image_id'=>$imageId,
                  'product_id'=>$productId,
                  'template_name'=>$existingtemplateName,
                  'name' => $name[$i],
                  'top' => $top[$i],
                  'left' => $left[$i],
                  'angle' => $angle[$i],
                  'font_size' =>$size[$i],
                  'font_family'=>$family[$i],
                  'width'=>$width[$i],
                  'height'=>$height[$i],
                  'effect'=>$effect[$i],
                  'curved_radius'=>$radius[$i],
                  'curved_spacing'=>$spacing[$i],
                  'curved_reverse'=>$reverse[$i],
                  'max_character'=> $character[$i],
                  'is_bold'=> $bold[$i],
                  'is_italic'=> $italic[$i],
                  'is_underline'=>$underline[$i],
                  'font_color'=>$fontColor[$i],
                  'text_align'=>$textAlignment[$i]
                  ));
                $templateTextModel->save();
                }
              }elseif(($existingtemplateName != '') && is_array($name) &&sizeof($name) != 0){
                if ($isAvailable == 0) {
                for ($i=0; $i < $count; $i++)
                {
                  $templateTextModel->setData(
                  array(
                  'image_id'=>$imageId,
                  'product_id'=>$productId,
                  'template_name'=>$existingtemplateName,
                  'name' => $name[$i],
                  'top' => $top[$i],
                  'left' => $left[$i],
                  'angle' => $angle[$i],
                  'font_size' =>$size[$i],
                  'font_family'=>$family[$i],
                  'width'=>$width[$i],
                  'height'=>$height[$i],
                  'effect'=>$effect[$i],
                  'curved_radius'=>$radius[$i],
                  'curved_spacing'=>$spacing[$i],
                  'curved_reverse'=>$reverse[$i],
                  'max_character'=> $character[$i],
                  'is_bold'=> $bold[$i],
                  'is_italic'=> $italic[$i],
                  'is_underline'=>$underline[$i],
                  'font_color'=>$fontColor[$i],
                  'text_align'=>$textAlignment[$i]
                  ));
                $templateTextModel->save();
                }
              }
              }
        if($textFlag == 0 && $newtemplateName!='' && is_array($name) && sizeof($name) != 0){
            for($i=0; $i < $count; $i++)
            {
               $templateTextModel->setData(
                  array(
                  'image_id'=>$imageId,
                  'product_id'=>$productId,
                  'template_name'=>$newtemplateName,
                  'name' => $name[$i],
                   'top' => $top[$i],
                   'left' => $left[$i],
                   'angle' => $angle[$i],
                   'font_size' =>$size[$i],
                   'font_family'=>$family[$i],
                   'width'=>$width[$i],
                   'height'=>$height[$i],
                   'effect'=>$effect[$i],
                   'curved_radius'=>$radius[$i],
                   'curved_spacing'=>$spacing[$i],
                   'curved_reverse'=>$reverse[$i],
                   'max_character'=> $character[$i],
                   'is_bold'=> $bold[$i],
                   'is_italic'=> $italic[$i],
                   'is_underline'=>$underline[$i],
                   'font_color'=>$fontColor[$i],
                   'text_align'=>$textAlignment[$i]
                  ));
                  $templateTextModel->save();
             }
          }
        }
        $imageFlag = 0;
        $imagemodel= $this->templateimageFactory;
        $templateimageCollection =$imagemodel->getCollection()
                ->addFieldToFilter('image_id', array('eq' => $imageId))
                ->addFieldToFilter('product_id',array('eq' => $productId));
        $templateimageNameCollection =$imagemodel->getCollection()
                ->addFieldToFilter('image_id', array('eq' => $imageId))
                ->addFieldToFilter('product_id',array('eq' => $productId))
                ->addFieldToFilter('template_name',array('eq' => $existingtemplateName));
        if($existingtemplateName == '' && is_array($imagename) && sizeof($imagename) != 0)
        {
            for($j = 0; $j < $imagecount; $j++)
            {
               $myfiles =  $this->_request->getFiles()->toArray(); 
              /*start upload image*/
              if(isset($myfiles['filename'][$j]['name']) && $myfiles['filename'][$j]['name'] != '') {
                $uploader = $this->_fileUploaderFactory->create(['fileId' => $files[$j]]);
                $uploader->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
                $uploader->setAllowRenameFiles(true);
                $fileName= uniqid() . '_uploaded.' .$uploader->getFileExtension();
                $path = $imageUrl = $this->directory_list->getPath('media').'/personalized/uploads/';                
                $resultdata = $uploader->save($path,$fileName);                



               $imagemodel->setData(
               array(
                   'image_id'=>$imageId,
                   'product_id'=>$productId,
                   'template_name'=>$newtemplateName,
                   'name' => $imagename[$j],
                   'top' => $imagetop[$j],
                   'left' => $imageleft[$j],
                   'angle' => $imageangle[$j],
                   'width'=>$imagewidth[$j],
                   'posting'=>$imageposting[$j],
                   'path'=>$fileName,
                   'height'=>$imageheight[$j]
               ));

              }else{

                if ($defaultimageobject[$j] == "No") {
                 $imagemodel->setData(
                 array(
                     'image_id'=>$imageId,
                     'product_id'=>$productId,
                     'template_name'=>$newtemplateName,
                     'name' => $imagename[$j],
                     'top' => $imagetop[$j],
                     'left' => $imageleft[$j],
                     'angle' => $imageangle[$j],
                     'width'=>$imagewidth[$j],
                     'posting'=>$imageposting[$j],
                     'height'=>$imageheight[$j]
                 ));                  
                }else{
                $imagemodel->setData(
                 array(
                     'image_id'=>$imageId,
                     'product_id'=>$productId,
                     'template_name'=>$newtemplateName,
                     'name' => $imagename[$j],
                     'top' => $imagetop[$j],
                     'left' => $imageleft[$j],
                     'angle' => $imageangle[$j],
                     'width'=>$imagewidth[$j],
                     'posting'=>$imageposting[$j],
                     'path'=>"",
                     'height'=>$imageheight[$j]
                 ));
                }


              }
                $imagemodel->save();
           }

       }else{
         $j = 0;
         $isAvailableImage = 0;
         foreach($templateimageCollection as $modelTemplate)
         {
            if($modelTemplate->getTemplateName() == $existingtemplateName){
              $imageFlag = 1;
              $isAvailableImage = 1;
              // Delete if image is not available
              if ($j >= $imagecount) {
                 $templateimageCollection =$imagemodel->getCollection()
                  ->addFieldToFilter('template_id',array('eq' => $modelTemplate->getTemplateId()))
                  ->walk('delete');

              } else {
                $imagemodel->load($modelTemplate->getTemplateId());



                 /*start upload image*/
                 $myfiles =  $this->_request->getFiles()->toArray(); 
              if(isset($myfiles['filename'][$j]['name']) && $myfiles['filename'][$j]['name'] != '') {
                $uploader = $this->_fileUploaderFactory->create(['fileId' => $files[$j]]);
                $uploader->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
                $uploader->setAllowRenameFiles(true);
                $fileName= uniqid() . '_uploaded.' .$uploader->getFileExtension();
                $path = $imageUrl = $this->directory_list->getPath('media').'/personalized/uploads/';                
                $resultdata = $uploader->save($path,$fileName);                



               $imagemodel->setData(
                array(
                    'template_id' =>$modelTemplate->getTemplateId(),
                    'image_id'=>$modelTemplate->getImageId(),
                    'product_id'=>$modelTemplate->getProductId(),
                    'template_name'=>$modelTemplate->getTemplateName(),
                    'name' => $imagename[$j],
                    'top' => $imagetop[$j],
                    'left' => $imageleft[$j],
                    'angle' => $imageangle[$j],
                    'width'=>$imagewidth[$j],
                    'posting'=>$imageposting[$j],
                    'path'=>$fileName,
                    'height'=>$imageheight[$j]
                ));

              }else{

                if ($defaultimageobject[$j] == "No") {
                 $imagemodel->setData(
                array(
                    'template_id' =>$modelTemplate->getTemplateId(),
                    'image_id'=>$modelTemplate->getImageId(),
                    'product_id'=>$modelTemplate->getProductId(),
                    'template_name'=>$modelTemplate->getTemplateName(),
                    'name' => $imagename[$j],
                    'top' => $imagetop[$j],
                    'left' => $imageleft[$j],
                    'angle' => $imageangle[$j],
                    'width'=>$imagewidth[$j],
                    'posting'=>$imageposting[$j],
                    'height'=>$imageheight[$j]
                ));          
                }else{
                $imagemodel->setData(
                array(
                    'template_id' =>$modelTemplate->getTemplateId(),
                    'image_id'=>$modelTemplate->getImageId(),
                    'product_id'=>$modelTemplate->getProductId(),
                    'template_name'=>$modelTemplate->getTemplateName(),
                    'name' => $imagename[$j],
                    'top' => $imagetop[$j],
                    'left' => $imageleft[$j],
                    'angle' => $imageangle[$j],
                    'width'=>$imagewidth[$j],
                    'posting'=>$imageposting[$j],
                    'path'=>"",
                    'height'=>$imageheight[$j]
                ));          
                }                




              }
                $imagemodel->save();
              }
              $j++;
            }
         }
         if ($imagecount > count($templateimageNameCollection) && $imageFlag == 1){
              for($j=0; $j < $imagecount; $j++)
              {


              /*start upload image*/
                $myfiles =  $this->_request->getFiles()->toArray(); 

              if(isset($myfiles['filename'][$j]['name']) && $myfiles['filename'][$j]['name'] != '') {
                $uploader = $this->_fileUploaderFactory->create(['fileId' => $files[$j]]);
                $uploader->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
                $uploader->setAllowRenameFiles(true);
                $fileName= uniqid() . '_uploaded.' .$uploader->getFileExtension();
                $path = $imageUrl = $this->directory_list->getPath('media').'/personalized/uploads/';                
                $resultdata = $uploader->save($path,$fileName);                

                $imagemodel->setData(
                 array(
                     'image_id'=>$imageId,
                     'product_id'=>$productId,
                     'template_name'=>$existingtemplateName,
                     'name' => $imagename[$j],
                     'top' => $imagetop[$j],
                     'left' => $imageleft[$j],
                     'angle' => $imageangle[$j],
                     'width'=>$imagewidth[$j],
                     'posting'=>$imageposting[$j],
                     'path'=>$fileName,
                     'height'=>$imageheight[$j]
                 ));

              }else{



                if ($defaultimageobject[$j] == "No") {
               $imagemodel->setData(
                 array(
                     'image_id'=>$imageId,
                     'product_id'=>$productId,
                     'template_name'=>$existingtemplateName,
                     'name' => $imagename[$j],
                     'top' => $imagetop[$j],
                     'left' => $imageleft[$j],
                     'angle' => $imageangle[$j],
                     'width'=>$imagewidth[$j],
                     'posting'=>$imageposting[$j],
                     'height'=>$imageheight[$j]
                 ));
                }else{
               $imagemodel->setData(
                 array(
                     'image_id'=>$imageId,
                     'product_id'=>$productId,
                     'template_name'=>$existingtemplateName,
                     'name' => $imagename[$j],
                     'top' => $imagetop[$j],
                     'left' => $imageleft[$j],
                     'angle' => $imageangle[$j],
                     'width'=>$imagewidth[$j],
                     'posting'=>$imageposting[$j],
                     'path'=>"",
                     'height'=>$imageheight[$j]
                 ));
                }                





              }
              /*end upload image*/

               $imagemodel->save();
              }

         }elseif(($existingtemplateName != '') && is_array($imagename) && sizeof($imagename) != 0){
          
          if($isAvailableImage == 0){
             for($j=0; $j < $imagecount; $j++)
              {

             /*start upload image*/
                $myfiles =  $this->_request->getFiles()->toArray(); 

              if(isset($myfiles['filename'][$j]['name']) && $myfiles['filename'][$j]['name'] != '') {
                $uploader = $this->_fileUploaderFactory->create(['fileId' => $files[$j]]);
                $uploader->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
                $uploader->setAllowRenameFiles(true);
                $fileName= uniqid() . '_uploaded.' .$uploader->getFileExtension();
                $path = $imageUrl = $this->directory_list->getPath('media').'/personalized/uploads/';                
                $resultdata = $uploader->save($path,$fileName);                


              $imagemodel->setData(
               array(
                   'image_id'=>$imageId,
                   'product_id'=>$productId,
                   'template_name'=>$existingtemplateName,
                   'name' => $imagename[$j],
                   'top' => $imagetop[$j],
                   'left' => $imageleft[$j],
                   'angle' => $imageangle[$j],
                   'width'=>$imagewidth[$j],
                   'posting'=>$imageposting[$j],
                   'path'=>$fileName,
                   'height'=>$imageheight[$j]
               ));
        
              }else{


              if ($defaultimageobject[$j] == "No") {
              $imagemodel->setData(
               array(
                   'image_id'=>$imageId,
                   'product_id'=>$productId,
                   'template_name'=>$existingtemplateName,
                   'name' => $imagename[$j],
                   'top' => $imagetop[$j],
                   'left' => $imageleft[$j],
                   'angle' => $imageangle[$j],
                   'width'=>$imagewidth[$j],
                   'posting'=>$imageposting[$j],
                   'height'=>$imageheight[$j]
               ));
                }else{
              $imagemodel->setData(
               array(
                   'image_id'=>$imageId,
                   'product_id'=>$productId,
                   'template_name'=>$existingtemplateName,
                   'name' => $imagename[$j],
                   'top' => $imagetop[$j],
                   'left' => $imageleft[$j],
                   'angle' => $imageangle[$j],
                   'width'=>$imagewidth[$j],
                   'posting'=>$imageposting[$j],
                   'path'=>"",
                   'height'=>$imageheight[$j]
               ));
                } 




              }
              /*end upload image*/

               $imagemodel->save();
              }
            }
         }
        /*Add new data if any*/
         if($imageFlag == 0 && $newtemplateName!='' && is_array($imagename) && sizeof($imagename) != 0){
              for($j = 0; $j < count($imagename); $j++)
              {


             /*start upload image*/
                            $myfiles =  $this->_request->getFiles()->toArray(); 
              if(isset($myfiles['filename'][$j]['name']) && $myfiles['filename'][$j]['name'] != '') {
                $uploader = $this->_fileUploaderFactory->create(['fileId' => $files[$j]]);
                $uploader->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
                $uploader->setAllowRenameFiles(true);
                $fileName= uniqid() . '_uploaded.' .$uploader->getFileExtension();
                $path = $imageUrl = $this->directory_list->getPath('media').'/personalized/uploads/';                
                $resultdata = $uploader->save($path,$fileName);                


               $imagemodel->setData(
               array(
                   'image_id'=>$imageId,
                   'product_id'=>$productId,
                   'template_name'=>$newtemplateName,
                   'name' => $imagename[$j],
                   'top' => $imagetop[$j],
                   'left' => $imageleft[$j],
                   'angle' => $imageangle[$j],
                   'width'=>$imagewidth[$j],
                   'posting'=>$imageposting[$j],
                   'path'=>$fileName,
                   'height'=>$imageheight[$j]
               ));
        
              }else{


              if ($defaultimageobject[$j] == "No") {
               $imagemodel->setData(
               array(
                   'image_id'=>$imageId,
                   'product_id'=>$productId,
                   'template_name'=>$newtemplateName,
                   'name' => $imagename[$j],
                   'top' => $imagetop[$j],
                   'left' => $imageleft[$j],
                   'angle' => $imageangle[$j],
                   'width'=>$imagewidth[$j],
                   'posting'=>$imageposting[$j],
                   'height'=>$imageheight[$j]
               ));
                }else{
               $imagemodel->setData(
               array(
                   'image_id'=>$imageId,
                   'product_id'=>$productId,
                   'template_name'=>$newtemplateName,
                   'name' => $imagename[$j],
                   'top' => $imagetop[$j],
                   'left' => $imageleft[$j],
                   'angle' => $imageangle[$j],
                   'width'=>$imagewidth[$j],
                   'posting'=>$imageposting[$j],
                   'path'=>"",
                   'height'=>$imageheight[$j]
               ));
                } 




              }
               $imagemodel->save();
              }
          }
       }
       $areaFlag = 0;
       $template_checked='notchecked';
       $newareaFlag = 0;
       $areaModel= $this->areaFactory;
       $areaCollection =$areaModel->getCollection()
                ->addFieldToFilter('image_id', array('eq' => $imageId))
                ->addFieldToFilter('product_id',array('eq' => $productId));
       if(count($areaCollection) == 0){
          $newareaFlag = 1;
          $templateName = $newtemplateName;
          $areaModel->setData(
              array(
               'image_id'=>$imageId,
               'product_id'=>$productId,
               'template_name'=>$newtemplateName,
               'template_checked'=>"notchecked",
               'x1' => $x1,
               'y1' => $y1,
               'x2' => $x2,
               'y2' => $y2,
               'width'=>$w,
               'height'=>$h,
               'is_ellipse'=>$is_ellipse,
               'template_overlay'=>$templateoverlay
               ));
          $areaModel->save();
       }else{
      
        foreach($areaCollection as $area){
        if($area->getTemplateName() == $existingtemplateName){
                $templateName = $existingtemplateName;
                $areaFlag = 1;
                $areaModel->load($area->getAreaId());
                  $areaModel->setData(
                  array(
                  'area_id'=>$area->getAreaId(),
                  'image_id'=>$area->getImageId(),
                  'product_id'=>$area->getProductId(),
                  'template_name'=>$area->getTemplateName(),
                  'x1' => $x1,
                  'y1' => $y1,
                  'x2' => $x2,
                  'y2' => $y2,
                  'width'=>$w,
                  'height'=>$h,
                  'is_ellipse'=>$is_ellipse,
                  'template_overlay'=>$templateoverlay
        ));
                $areaModel->save();
        $template_checked=$area->getTemplateChecked();
              }
          }
          if($areaFlag == 0 && $newtemplateName!=''){
              $templateName = $newtemplateName;
              $newareaFlag = 1;
              $areaModel->setData(
              array(
                'image_id'=>$imageId,
                'product_id'=>$productId,
                'template_name'=>$newtemplateName,
                'x1' => $x1,
                'y1' => $y1,
                'x2' => $x2,
                'y2' => $y2,
                'width'=>$w,
                'height'=>$h,
                'is_ellipse'=>$is_ellipse,
                'template_overlay'=>$templateoverlay
              ));
              $template_checked=$area->getTemplateChecked();
                $areaModel->save();
              }
        }
         $result->setData(
         [
            'templatename'=>$templateName,
            'checked' => $template_checked
         ]);
         return $result;
      }
      $areaModel = $this->areaFactory;
      for($z=0; $z<sizeof($checkboxChecked); $z++){
           $areaCollection = $areaModel->getCollection()
              ->addFieldToFilter('image_id', array('eq' => $imageId))
              ->addFieldToFilter('product_id',array('eq' => $productId))
              ->addFieldToFilter('template_name',array('eq' => $checkboxChecked[$z]));
          foreach($areaCollection as $area){
            $areaModel->load($area->getAreaId());
            $areaModel->setData(
            array(
              'area_id'=>$area->getAreaId(),
              'template_checked'=> "checked"
            ));
            $areaModel->save();
          }
      }
      for($z=0; $z<sizeof($checkboxNotChecked); $z++){
           $areaCollection = $areaModel->getCollection()
              ->addFieldToFilter('image_id', array('eq' => $imageId))
              ->addFieldToFilter('product_id',array('eq' => $productId))
              ->addFieldToFilter('template_name',array('eq' => $checkboxNotChecked[$z]));
          foreach($areaCollection as $area){
            $areaModel->load($area->getAreaId());
            $areaModel->setData(
            array(
              'area_id'=>$area->getAreaId(),
              'template_checked'=> "notchecked"
            ));
            $areaModel->save();
          }
      }

    }
  }
