<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products.html
 *
 *
 */

namespace Milople\Personalizedrich\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filesystem\Io\File;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Milople\Personalizedrich\Model\AreaFactory;
use Psr\Log\LoggerInterface;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Template extends Action
{

    protected $templateFactory;

    public function __construct(
        Context         $context,
        File            $filesystem,
        DirectoryList   $directory_list,
        JsonFactory     $resultJsonFactory,
        AreaFactory     $areaFactory,
        Personalized    $helper,
        LoggerInterface $logger
    )
    {
        $this->_request = $context->getRequest();
        $this->filesystem = $filesystem;
        $this->directory_list = $directory_list;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        $this->areaFactory = $areaFactory;
        $this->helper = $helper;
        $this->resultJsonFactory = $resultJsonFactory;
        return parent::__construct($context);
    }

    public function execute()
    {
        $result = $this->resultJsonFactory->create();
        $canvas = [];
        $baseUrl = $this->helper->getBaseUrl();
        $templateNameArray = [];
        $resizedUrl = [];
        $postdata = $this->_request->getPost();
        $width = $this->helper->getWidth();
        $height = $this->helper->getHeight();
        $productId = $postdata['productId'];
        $addtemplatename = 0;
        $templateArray = [];
        $templateArrayCount = 0;
        $templateNameArray = [];
        $addtemplatename = 0;
        $areaModel = $this->areaFactory->create();
        $areaCollection = $areaModel->getCollection()->addFieldToFilter('product_id', ['eq' => $productId]);
        foreach ($areaCollection as $area) {
            if ($area->getTemplateName() != '') {
                if ($area->getTemplateChecked() == "checked") {
                    $templateArray[$templateArrayCount]['imageid'] = $area->getImageId();
                    $templateArray[$templateArrayCount]['checked'] = $area->getTemplateName();
                    $templateArray[$templateArrayCount]['x1'] = $area->getData('x1');
                    $templateArray[$templateArrayCount]['y1'] = $area->getData('y1');
                    $templateArray[$templateArrayCount]['x2'] = $area->getData('x2');
                    $templateArray[$templateArrayCount]['y2'] = $area->getData('y2');
                    $templateArray[$templateArrayCount]['width'] = $area->getWidth();
                    $templateArray[$templateArrayCount]['height'] = $area->getHeight();
                    $templateArray[$templateArrayCount]['is_ellipse'] = $area->getIsEllipse();
                    $templateArrayCount++;
                } else {
                    $templateArray[$templateArrayCount]['imageid'] = $area->getImageId();
                    $templateArray[$templateArrayCount]['checked'] = "notchecked";
                    $templateArrayCount++;
                }
                $templateNameArray[$addtemplatename] = $area->getTemplateName();
                $addtemplatename++;
            }
        }
        $result->setData([
            'templateArray' => $templateArray, 'templatenames' => $templateNameArray]);
        return $result;
    }
}
