<?php
/**
*
* Do not edit or add to this file if you wish to upgrade the module to newer
* versions in the future. If you wish to customize the module for your
* needs please contact us to https://www.milople.com/contact-us.html
*
* @category    Ecommerce
* @package     Milople_Personlized
* @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
* @url         https://www.milople.com/magento2-extensions/personalized-products.html
*
**/
namespace Milople\Personalizedrich\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filesystem\Io\File;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Milople\Personalizedrich\Model\AreaFactory;
use Milople\Personalizedrich\Model\Templateimage;
use Psr\Log\LoggerInterface;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Templatepreview extends Action
{

    public function __construct(
        Context                                  $context,
        File                                     $filesystem,
        DirectoryList                            $directory_list,
        JsonFactory                              $resultJsonFactory,
        \Milople\Personalizedrich\Model\Template $templateFactory,
        Templateimage                            $templateImageFactory,
        AreaFactory                              $areaFactory,
        Personalized                             $helper,
        LoggerInterface                          $logger
    )
    {
        $this->_request = $context->getRequest();
        $this->filesystem = $filesystem;
        $this->directory_list = $directory_list;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_logger = $logger;
        $this->templateFactory = $templateFactory;
        $this->templateImageFactory = $templateImageFactory;
        $this->areaFactory = $areaFactory;
        $this->helper = $helper;
        $this->resultJsonFactory = $resultJsonFactory;
        return parent::__construct($context);
    }

    public function execute()
    {
      $result = $this->resultJsonFactory->create();
      $canvas=array();
      $postdata = $this->_request->getPost();
	  	$productId=$postdata['productId'];
      $templateName=$postdata['previewId'];
      $x1 = 0;
      $y1 = 0;
      $w = 0;
      $h = 0;
			$add=1;
			$table="" ;
      // Getting Template Text Objects
			$model= $this->templateFactory;
      $tempalteCollection = $model->getCollection()
                ->addFieldToFilter('template_name', array('eq' => $templateName));
			foreach ($tempalteCollection as $template)
			{
				  $table.="<tr id='addr" .$add. "'><td>".$add. "</td>
				  <td><input name='select' id='radioName".$add. "' type='radio' class='pointSelection'checked='checked' placeholder='Name' value='".$add. "'/> </td>
          <td><input id='Xname".$add. "' name='left[]' type='text' placeholder='X'  class='form-control input-md' value='".$template->getLeft()."' readonly/></td>
          <td><input id='Yname".$add. "'  name='top[]' type='text' placeholder='Y' class='form-control input-md' value='".$template->getTop(). "' readonly/></td>
          <td><input id='Angle".$add. "' type='text' name='angle[]' placeholder='Angle' class='form-control' value='".$template->getAngle(). "' readonly/></td>
          <td><input id='name".$add."' type='text' name='name[]' placeholder='Name' class='form-control' value='".$template->getName(). "' readonly/></td>
          <td><input id='character".$add."' type='text' name='character[]' placeholder='Max Characters' class='form-control' value='".$template->getMaxCharacter(). "' readonly/></td>
          <td><input id='width".$add."' type='text' name='width[]' placeholder='Width' class='form-control' value='".$template->getWidth(). "' readonly/></td>
          <td><input id='height".$add."' type='text' name='height[]' placeholder='Height' class='form-control' value='".$template->getHeight(). "' readonly/></td>
          <td><input id='size".$add."' type='text' name='size[]' placeholder='Size' class='form-control' value='".$template->getFontSize(). "' readonly/></td>
          <td><input id='family".$add."' type='text' name='family[]' placeholder='Font Family' class='form-control' value='".$template->getFontFamily(). "' readonly/></td>
          <td><input id='effect".$add."' type='text' name='effect[]' placeholder='Effect' class='form-control' value='".$template->getEffect(). "'/></td>
          <td style='display:none'><input id='radius".$add."' type='hidden' name='radius[]' placeholder='Radius' class='form-control' value='".$template->getCurvedRadius(). "'/></td>
          <td style='display:none'><input id='spacing".$add."' type='hidden' name='spacing[]' placeholder='Spacing' class='form-control' value='".$template->getCurvedSpacing(). "'/></td>
          <td style='display:none'><input id='reverse".$add."' type='hidden' name='reverse[]' placeholder='Reverse' class='form-control' value='".$template->getCurvedReverse(). "'/></td>
          <td style='display:none'><input id='bold".$add."' type='hidden' name='bold[]' placeholder='Bold' class='form-control' value='".$template->getIsBold(). "'/></td>
          <td style='display:none'><input id='italic".$add."' type='hidden' name='italic[]' placeholder='Italic' class='form-control' value='".$template->getIsItalic(). "'/></td>
          <td style='display:none'><input id='underline".$add."' type='hidden' name='underline[]' placeholder='Underline' class='form-control' value='".$template->getIsUnderline(). "'/></td>
          <td style='display:none'><input id='font_color".$add."' type='hidden' name='font_color[]' placeholder='Font Color' class='form-control' value='".$template->getFontColor(). "'/></td>
          <td><input id='text_align".$add."' type='text' name='text_align[]' placeholder='Text Alignment' class='form-control' value='".$template->getTextAlign(). "' readonly/></td>
          </tr>";
          $canvas[$add]['imageid']=$template->getImageId();
          $canvas[$add]['canvasid']=$template->getTemplateId();
          $canvas[$add]['top']=$template->getTop();
          $canvas[$add]['left']=$template->getLeft();
          $canvas[$add]['angle']=$template->getAngle();
          $canvas[$add]['name']=$template->getName();
          $canvas[$add]['character']=$template->getMaxCharacter();
          $canvas[$add]['width']=$template->getWidth();
          $canvas[$add]['height']=$template->getHeight();
          $canvas[$add]['size']=$template->getFontSize();
          $canvas[$add]['family']=$template->getFontFamily();
          $canvas[$add]['effect']=$template->getEffect();
          $canvas[$add]['radius']=$template->getCurvedRadius();
          $canvas[$add]['spacing']=$template->getCurvedSpacing();
          $canvas[$add]['reverse']=$template->getCurvedReverse();
          $canvas[$add]['bold']=$template->getIsBold();
          $canvas[$add]['italic']=$template->getIsItalic();
          $canvas[$add]['underline']=$template->getIsUnderline();
          $canvas[$add]['font_color']=$template->getFontColor();
          $canvas[$add]['text_align']=$template->getTextAlign();
          $add++;
		  }
		  $table.="</tr>";
      $imagetable = "";
      $addimage = 1;
      $imagecanvas = array();
      /*Getting Template Image Objects*/
		  $templateImageModel = $this->templateImageFactory;
	    $templateImageCollection = $templateImageModel->getCollection()
                ->addFieldToFilter('template_name',array('eq' => $templateName));
		  foreach ($templateImageCollection as $imagetemplate)
			{
        $default = 'No';
        if($imagetemplate->getPath() == "")
        { 
          $default = 'Yes'; 
        }


				$imagetable.="<tr id='image" .$addimage. "'><td>".$addimage. "</td>
				<td><input name='imageselect' id='radioImage".$addimage. "' type='radio' class='pointSelection'checked='checked' placeholder='Name' value='".$addimage. "'/> </td>
				<td><input id='imagename".$addimage."' type='text' name='imagename[]' placeholder='Name' class='form-control' value='".$imagetemplate->getName(). "' readonly/></td>
        <td><input id='imageleft".$addimage. "'  name='imageleft[]' type='text' placeholder='X' class='form-control input-md' value='".$imagetemplate->getLeft(). "' readonly/></td>
        <td><input id='imagetop".$addimage. "' name='imagetop[]' type='text' placeholder='Y'  class='form-control input-md' value='".$imagetemplate->getTop()."' readonly/></td>
				<td><input id='imageangle".$addimage. "' type='text' name='imageangle[]' placeholder='Angle' class='form-control' value='".$imagetemplate->getAngle(). "' readonly/></td>
        <td><input class='imagefilesdata' id='imagefile".$addimage."' type='file' name='filename[]' data-name='imageobject".$addimage."' class='form-control'></td>
        <td><button class='selectbtnobject form-control btn btn-primary' data-imageid='imageobject".$addimage."' >Select</button></td>
				<td style='display:none;'><input id='imagewidth".$addimage."' type='hidden' name='imagewidth[]' placeholder='Width' class='form-control' value='".$imagetemplate->getWidth(). "' readonly/></td>
				<td style='display:none'><input id='imageheight".$addimage."' type='hidden' name='imageheight[]' placeholder='Height' class='form-control' value='".$imagetemplate->getHeight(). "' readonly/></td>
        <td style='display:none'><input id='postingimageobject".$addimage."' type='hidden' name='imageposting[]' placeholder='Side' class='imageposting form-control' value='".$imagetemplate->getPosting()."'/></td>
        <td style='display:none'><input id='defaultimageobject".$addimage."' type='hidden' name='defaultimageobject[]' placeholder='default' class='defaultimage form-control' value='".$default."'/></td>
        </tr>";
        $imagecanvas[$addimage]['imageid']=$imagetemplate->getImageId();
        $imagecanvas[$addimage]['canvasid']=$imagetemplate->getTemplateId();
        $imagecanvas[$addimage]['imagename']=$imagetemplate->getName();
				$imagecanvas[$addimage]['imagetop']=$imagetemplate->getTop();
				$imagecanvas[$addimage]['imageleft']=$imagetemplate->getLeft();
				$imagecanvas[$addimage]['imageangle']=$imagetemplate->getAngle();
				$imagecanvas[$addimage]['imagewidth']=$imagetemplate->getWidth();
				$imagecanvas[$addimage]['imageheight']=$imagetemplate->getHeight();
        $imagecanvas[$addimage]['posting']=$imagetemplate->getPosting();
        $imagecanvas[$addimage]['path']=$imagetemplate->getPath();
				$addimage++;
		}
		$imagetable.="</tr>";
    $areaModel = $this->areaFactory->create();
	  $areaCollection = $areaModel->getCollection()
            ->addFieldToFilter('template_name',array('eq' => $templateName));
    foreach($areaCollection as $area){
        if($area->getAreaId()!='') {
            $imageid=$area->getData('image_id');
			      $x1=$area->getData('x1');
			      $y1=$area->getData('y1');
            $x2=$area->getData('x2');
			      $y2=$area->getData('y2');
            $w=$area->getData('width');
            $h=$area->getData('height');
            $is_ellipse=$area->getData('is_ellipse');
            $template_overlay=$area->getData('template_overlay');
		    }
    }
    $result->setData(
    	['table' => $table,
       'imagetable' => $imagetable,
    	 'canvas'=> $canvas,
       'imagecanvas' => $imagecanvas,
       'imageid'=> $imageid,
       'x1' => $x1,
			 'y1' => $y1,
       'x2' => $x2,
       'y2' => $y2,
       'w' => $w,
       'h' => $h,
       'is_ellipse' => $is_ellipse,
       'template_overlay' => $template_overlay,
      ]);
      return $result;
   }
}
