<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/
namespace Milople\Personalizedrich\Helper\Product\View;

use Magento\Bundle\Helper\Catalog\Product\Configuration;
use Magento\Bundle\Model\Product\Type;
use Magento\Catalog\Model\Product;
use Magento\Catalog\Model\ProductRepository;
use Magento\Directory\Model\Currency;
use Magento\Eav\Model\Config;
use Magento\Eav\Model\ResourceModel\Entity\Attribute;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\DeploymentConfig;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\App\ProductMetadataInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\ResourceConnection;
use Magento\Framework\Filesystem;
use Magento\Framework\Image\AdapterFactory;
use Magento\Framework\Serialize\SerializerInterface;
use Magento\Framework\UrlInterface;
use Magento\Framework\View\LayoutInterface;
use Magento\Store\Model\ScopeInterface;
use Magento\Store\Model\StoreManagerInterface;
use Milople\Personalizedrich\Api\CategoryRepositoryInterface;
use Milople\Personalizedrich\Model\Area;
use Milople\Personalizedrich\Model\CategoryFactory;
use Milople\Personalizedrich\Model\ImageFactory;
use Milople\Personalizedrich\Model\QuotecategoryFactory;
use Milople\Personalizedrich\Model\QuoteFactory;
use Milople\Personalizedrich\Model\ResourceModel\Category;
use Milople\Personalizedrich\Model\ResourceModel\Image\CollectionFactory;
use Milople\Personalizedrich\Model\Template;
use Milople\Personalizedrich\Model\Templateimage;
use Psr\Log\LoggerInterface;
use ZIPARCHIVE;
use Milople\Personalizedrich\Model\CategoryProduct;
use Milople\Personalizedrich\Model\CategoryImage;
use Magento\Framework\Registry;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class Personalized extends AbstractHelper
{
    const IMAGEPATH = 'personalized/images/';
    public $_storeManager;
    protected $categoryProduct;
    protected $categoryImage;
    protected $scopeConfig;
    protected $category;
    protected $images;
    protected $categoryRepository;
    protected $resource;
    protected $_filesystem;
    protected $_imageFactory;
    protected $eavConfig;
    protected $quoteFactory;
    protected $quotecategoryFactory;
    protected $serializer;
    protected $noOfSize;

    public function __construct(
        CategoryProduct             $categoryProduct,
        CategoryImage               $categoryImage,
        RequestInterface            $httpRequest,
        ScopeConfigInterface        $scopeConfig,
        LoggerInterface             $logger,
        Product                     $product,
        StoreManagerInterface       $storeManager,
        LayoutInterface             $layout,
        CategoryRepositoryInterface $categoryRepository,
        CategoryFactory             $categoryModel,
        Category                    $rCategory,
        ImageFactory                $imageModel,
        ResourceConnection          $resource,
        Area                        $areaFactory,
        Template                    $templateFactory,
        Config                      $eavConfig,
        QuotecategoryFactory        $quotecategoryFactory,
        QuoteFactory                $quoteFactory,
        Templateimage               $templateImageFactory,
        Filesystem                  $filesystem,
        AdapterFactory              $imageFactory,
        ProductRepository           $productRepo,
        Type                        $bundleselection,
        Currency                    $currency,
        DeploymentConfig            $deploymentConfig,
        ProductMetadataInterface    $mageInfo,
        SerializerInterface         $serializer,
        Configuration               $bundleProductConfiguration,
        Attribute                   $entityAttribute,
        Registry                    $registry
    )
    {
        $this->_productRepo = $productRepo;
        $this->scopeConfig = $scopeConfig;
        $this->storeManager = $storeManager;
        $this->serializerdata = $serializer;
        $this->logger = $logger;
        $this->request = $httpRequest;
        $this->categoryRepository = $categoryRepository;
        $this->_storeManager = $storeManager;
        $this->_layout = $layout;
        $this->areaFactory = $areaFactory;
        $this->templateFactory = $templateFactory;
        $this->templateImageFactory = $templateImageFactory;
        $this->category = $categoryModel;
        $this->rCategory = $rCategory;
        $this->resource = $resource;
        $this->product = $product;
        $this->images = $imageModel;
        $this->_filesystem = $filesystem;
        $this->_imageFactory = $imageFactory;
        $this->_bundleProductConfiguration = $bundleProductConfiguration;
        $this->_bundleSelection = $bundleselection;
        $this->_currency = $currency;
        $this->eavConfig = $eavConfig;
        $this->mageInfo = $mageInfo;
        $this->quoteFactory = $quoteFactory;
        $this->quotecategoryFactory = $quotecategoryFactory;
        $this->deploymentConfig = $deploymentConfig;
        $this->entityAttribute = $entityAttribute;
        $this->categoryProduct = $categoryProduct;
        $this->categoryImage = $categoryImage;
        $this->registry = $registry;
    }

    public function create_zip($destination ,$files = [])
    {
        $valid_files = [];
        $overwrite = false;
        if (is_array($files)) {
            foreach ($files as $file) {
                if (file_exists($file)) {
                    $valid_files[] = $file;
                }
            }
        }
        if (count($valid_files)) {
            $zip = new ZipArchive();
            if ($zip->open($destination, $overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
                return false;
            }
            foreach ($valid_files as $file) {
                $zip->addFile($file, basename($file));
            }
            $zip->close();
            header('Content-Type: application/zip');
            header('Content-disposition: attachment; filename=' . $destination);
            header('Content-Length: ' . filesize($destination));
            readfile($destination);
            unlink($destination);
        }
    }
    public function getProductId()
    {
        return $this->registry;
    }

    public function getMagentoVersion()
    {
        $version = $this->mageInfo->getVersion();
        return $version;
    }

    public function getCurrencySymbol() {
        return $this->_storeManager-> getStore()->getBaseCurrency()->getCurrencySymbol();
    }



    public function getOptionList($item)
    {
        return $this->_bundleProductConfiguration->getOptions($item);
    }

    public function getChildrenIds($parentId, $required = true)
    {
        return $this->_bundleSelection->getChildrenIds($parentId, $required);
    }


    public function array_flatten($array) {
        if (!is_array($array)) {
            return FALSE;
        }
        $result = array();
        foreach ($array as $key => $value) {
            if (is_array($value)) {
                $result = array_merge($result, array_flatten($value));
            }
            else {
                $result[$key] = $value;
            }
        }
        return $result;
    }

    /*General Function for generating Configuration*/
    public function getConfig($config_path)
    {
        return $this->scopeConfig->getValue($config_path,ScopeInterface::SCOPE_STORE
        );
    }
    /*get Image Media URL*/
    public function getImageMediaUrl($fileName)
    {
        $path = $this->_storeManager->getStore()->getBaseUrl(UrlInterface::URL_TYPE_MEDIA);
        $imageUrls = $fileName;
        if (!is_array($imageUrls)) {
            $imageUrls = explode(" ", $imageUrls);
        }
        foreach ($imageUrls as $imageName) {
            $imageName = explode(",", $imageName);
            foreach ($imageName as $image) {
                if ($image != 'blank') {
                    $images[] = $path . self::IMAGEPATH . $image;
                } else {
                    $images[] = 'blank';
                }
            }
        }
        return $images;
    }

    /*get Image Name*/
    public function getImageName($fileName)
    {
        $imageUrls = $fileName;
        if (!is_array($imageUrls)) {
            $imageUrls = explode(" ",(string)$imageUrls ?? '');
        }
        foreach ($imageUrls as $imageName) {
            $imageName = explode(",",(string) $imageName);
            foreach ($imageName as $image) {
                if ($image != 'blank') {
                    $images[] = $image;
                } else {
                    $images[] = 'blank';
                }
            }
        }
        return $images;
    }

    /*Get original Media if module is disabled.*/
    public function getMedia($galleryOptions,$imageHelper=null)
    {
        $html = $this->_layout
            ->createBlock('Magento\Catalog\Block\Product\View\Gallery')
            ->setData('gallery_options', $galleryOptions)
            ->setData('imageHelper', $imageHelper)
            ->setTemplate('Magento_Catalog::product/view/gallery.phtml')
            ->toHtml();

        return $html;
    }
    # Get product by id
    public function getProductById($id)
    {
        return $this->_productRepo->getById($id);
    }

    /*Get clipart category*/
    public function getCategory($id)
    {
        $categoryId= $this->getProductCategory($id);
        if(count($categoryId)>0){
            $categoryModel=$this->category->create()->getCollection();
            return $categoryModel->addFieldToFilter('name', array('neq'=>''))->addFieldToFilter('status', '1')->addFieldToFilter('category_id', ['in' => $categoryId]);
        }else{
            return array();
        }
    }
    /*Get all image for clipart*/
    public function getAllImages()
    {
        $imageModel=$this->images->create()->getCollection();
        return $imageModel->addFieldToFilter('name', array('neq'=>''))
            ->addFieldToFilter('status', '1');
    }

    public function getProductCategory($productId){
        $connection = $this->resource->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        $select = $connection->select()
            ->from(
                ['test' => $this->rCategory->getCategoryProductTable() ],
                ['category_id']
            )->where(
                'product_id = :product_id'
            );

        $binds = [':product_id' => (int) $productId];
        $oldProducts = $connection->fetchAll($select, $binds);
        $result = array();
        foreach ($oldProducts as $i => $k) {
            $result[] = $k['category_id'];
        }
        return $result;
    }

    /*Get Media URL*/
    public function getMediaPath()
    {
        $mediaUrl = $this->_storeManager->getStore()->getBaseUrl(UrlInterface::URL_TYPE_MEDIA);
        return $mediaUrl;
    }

    /*Check check image status*/
    public function checkCategoryImageStatus($id)
    {
        $connection = $this->resource->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        $tblPersonalizedImage = $this->deploymentConfig->get('db/table_prefix').'personalized_category_category_image';
        $result=$connection->fetchAll('SELECT category_id FROM `'.$tblPersonalizedImage.'` WHERE image_id='.$id);
        return $this->checkCategoryStatus($result);
    }

    /*Check category status enabled or not for image*/
    public function checkCategoryStatus($results)
    {
        $status = false;
        foreach ($results as $result) {
            $categoryModel = $this->category->create()->getCollection();
            $categoryModel->addFieldToFilter('category_id', $result['category_id'])->addFieldToFilter('status', '1');
            $hasData = count($categoryModel);
            if ($hasData) {
                $status = true;
            }
        }
        return $status;
    }

    /*get Base url of store*/
    public function getBaseUrl()
    {
        return $this->_storeManager->getStore()->getBaseUrl();
    }

    /*get Category image for clipart*/
    public function getFilteredCategoryImage($id)
    {
        $connection = $this->resource->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        $tblImage= $this->deploymentConfig->get('db/table_prefix').'personalized_category_image';
        $tblCategory = $this->deploymentConfig->get('db/table_prefix').'personalized_category_category_image';
        if($id!='') {
            $results=$connection->fetchAll('SELECT * FROM `' .$tblImage.'` ,`'.$tblCategory.'` WHERE `'.$tblImage.'`.image_id=`'.$tblCategory.'`.image_id and `'.$tblCategory.'`.category_id='.$id.' and `'.$tblImage.'`.status=1');
        }else{
            $results=$this->getAllImages();
        }

        $thumbWidth='50px';
        $thumbHeight='50px';
        $clipartCustomPriceEnable = $this->getConfig('personalizedrich/Image_setting_group/clipart_price_enabled');

        $rawHtml='<div id="image_list" class="image_list">';
        foreach ($results as $result) {
            if($this->checkCategoryImageStatus($result['image_id'])){
                $src=$this->getMediaPath().$result['path'];

                if($clipartCustomPriceEnable == 1)
                {
                    $rawHtml.='<div style="text-align: center;float: left;">';
                    $rawHtml.='<img style="margin: auto;padding: 8px;display: block;width:'.$thumbWidth .';height:'. $thumbHeight.';" 
                    src="'.$src .'" class="clipart-image" alt="'.$result['name'] .'" title="'.$result['name'] .'" data-price="'.$result['price'] .'">';
                    $rawHtml.='<span>'.$this->getCurrencySymbol()."".$result['price'] .'</span>';
                    $rawHtml.='</div>';
                }
                else
                {
                    $rawHtml.='<img style="width:'.$thumbWidth .';height:'. $thumbHeight.';" src="'.$src .'" class="clipart-image"  alt="'.$result['name'] .'" title="'.$result['name'] .'">';
                }
            }
        }
        $rawHtml.='</div>';
        return $rawHtml;
    }
    /*check product has area defined*/
    public function isRestrictedAreaDrawn($product, $fromWhere = 'Media')
    {
        $result = false;
        $model = $this->areaFactory;
        $areaCollection = $model->getCollection()->addFieldToFilter('product_id', ['eq' => $product->getId()]);
        if ($areaCollection->count() > 0) {
            $result = true;
        }
        return $result;
    }

    /*Check image has area defined*/
    public function isImageHasArea($productId, $imageId)
    {
        $result = "not allowed";
        $model = $this->areaFactory;
        $areaCollection = $model->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->addFieldToFilter('product_id', ['eq' => $productId]);
        if ($areaCollection->count() >= 1) {
            $result = 'allowed';
        }
        return $result;
    }
    /*Check product has side.*/
    public function isProductHasSide($product)
    {
        $result = false;
        $model = $this->areaFactory;
        $areaCollection = $model->getCollection()->addFieldToFilter('product_id', ['eq' => $product->getId()]);
        if ($areaCollection->count() > 1) {
            $result = true;
        }
        return $result;
    }

    /*Get Area value based on product , image id and label*/
    public function getCoordinates($productId,$imageId,$label)
    {
        $model=$this->areaFactory;
        $areaCollection=$model->getCollection()->addFieldToFilter('image_id',array('eq' => $imageId))->addFieldToFilter('product_id',array('eq' => $productId));
        $area=$areaCollection->getFirstItem();
        $result;
        switch($label){
            case "X1" :
                $result=$area->getData('x1');
                break;
            case "X2" :
                $result=$area->getData('x2');
                break;
            case "Y1" :
                $result=$area->getData('y1');
                break;
            case "Y2" :
                $result=$area->getData('y2');
                break;
            case "Width":
                $result=$area->getData('width');
                break;
            case "Height":
                $result=$area->getData('height');
                break;
            case "Templateprice":
                $result=$area->getData('templateprice');
                break;
            case "Areaid":
                $result=$area->getData('area_id');
                break;
        }
        return $result;
    }

    /*Get product side count from product.*/
    public function getSideCount($product){
        $model=$this->areaFactory;
        $areaCollection=$model->getCollection()->addFieldToFilter('product_id',array('eq' => $product->getId()));
        $a = array();
        if ($areaCollection->count() !=0) {
            foreach ($areaCollection as $data) {
                if (!in_array($data['image_id'], $a)) {
                    array_push($a,$data['image_id']);
                }
            }
        }
        return count($a);
    }

    /*Check product having template and image.*/
    public function isTemplateThere($product)
    {
        $result = false;
        $model = $this->templateFactory;
        $templateCollection = $model->getCollection()->addFieldToFilter('product_id', ['eq' => $product->getId()]);
        if ($templateCollection->count() > 0) {
            $result = true;
        }
        $model = $this->templateImageFactory;
        $templateImageCollection = $model->getCollection()->addFieldToFilter('product_id', ['eq' => $product->getId()]);
        if ($templateImageCollection->count() > 0) {
            $result = true;
        }
        return $result;
    }

    /*Create template image factory.*/
    public function getTemplateImageCollection($product,$imageId)
    {
        $productId=$product->getId();
        $model=$this->templateImageFactory;
        $templateImageCollection=$model->getCollection()->addFieldToFilter('image_id',array('eq' => $imageId))->addFieldToFilter('product_id',array('eq' => $productId));
        return $templateImageCollection;
    }

    /*Resize the image before showing on product page.*/
    public function resize($image, $width = null, $height = null)
    {
        $absolutePath = $this->_filesystem->getDirectoryRead(DirectoryList::MEDIA)->getAbsolutePath('catalog/product/') . $image;
        $imageResized = $this->_filesystem->getDirectoryRead(DirectoryList::MEDIA)->getAbsolutePath('personalized/resized/' . $width . '/') . $image;
        $imageResize = $this->_imageFactory->create();
        $imageResize->open($absolutePath);
        $imageResize->constrainOnly(true);
        $imageResize->keepTransparency(true);
        $imageResize->keepFrame(false);
        $imageResize->keepAspectRatio(false);
        $imageResize->resize($width, $height);
        $destination = $imageResized;
        $imageResize->save($destination);
        $resizedURL = $this->_storeManager->getStore()->getBaseUrl(UrlInterface::URL_TYPE_MEDIA) . 'personalized/resized/' . $width . '/' . $image;
        return $resizedURL;
    }

    /*Get template based on product and image id*/
    public function getTemplateCollection($product, $imageId)
    {
        $productId = $product->getId();
        $model = $this->templateFactory;
        $templateCollection = $model->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->addFieldToFilter('product_id', ['eq' => $productId]);
        return $templateCollection;
    }

    /*Get Base image id of product*/
    public function getBaseImageId($product, $imageHelper)
    {
        $image = 'product_base_image';
        $url = $imageHelper->init($product, $image)->constrainOnly(false)->keepAspectRatio(false)->keepFrame(false)->getUrl();
        $imageCollection = $product->getMediaGalleryImages();
        foreach ($imageCollection as $image) {
            if (basename($image->getUrl()) == basename($url)) {
                return $image->getId();
            }
        }
    }

    public function getWidth(){
        return $this->getConfig('personalizedrich/area_setting_group/width');
    }

    public function getHeight(){
        return $this->getConfig('personalizedrich/area_setting_group/height');
    }

    /*Get Base Image of cofigurable product`s simple products*/
    public function getBaseImage($productId, $imageHelper)
    {
        $image = 'product_base_image';
        $product = $this->product->load($productId);
        $width = $this->getConfig('personalizedrich/area_setting_group/width');
        $height = $this->getConfig('personalizedrich/area_setting_group/height');
        $url = $imageHelper->init($product, $image)->constrainOnly(false)->keepAspectRatio(false)->resize($width, $height)->keepFrame(false)->getUrl();
        $imageCollection = $product->getMediaGalleryImages();
        foreach ($imageCollection as $image) {
            if (basename($image->getUrl()) == basename($url)) {
                return ['id' => $image->getId(), 'url' => $url];
            }
        }
    }

    /*To get Enabled Quote Categories in Form*/
    public function getQuoteCategoryNames()
    {
        $array['']='--Please Select--';
        $model = $this->quotecategoryFactory->create();
        $collections=$model->getCollection()->addFieldToFilter('status', '1');
        foreach($collections as $res){
            $array[$res->getName()] = $res->getName();
        }
        return $array;
    }
    /*To get Enabled Categories in Quotes tab of product page*/
    public function getQuoteCategory()
    {
        $quotecategoryFactory=$this->quotecategoryFactory->create()->getCollection();
        return $quotecategoryFactory->addFieldToFilter('name', array('neq'=>''))->addFieldToFilter('status', '1');
    }
    /*To get all the quotes*/
    public function getAllQuotes()
    {
        $quoteFactory=$this->quoteFactory->create()->getCollection();
        return $quoteFactory->addFieldToFilter('quote', array('neq'=>''))->addFieldToFilter('status', '1');
    }

    public function getSizes($size){
        $unserialize = $this->getUnserializedData($size);
        return $unserialize;
    }

    public function getSizeArray(){
        $attribute = $this->eavConfig->getAttribute('catalog_product', 'size_dropdown');
        $options = $attribute->getSource()->getAllOptions(true,true);
        return $options;
    }

    public function getSizeLabel($sizes){
        $count = 0;
        $array = array();
        $size_array = $this->getSizeArray();
        foreach($sizes as $size){
            $count++;
        }
        for($i=0; $i<$count; $i++){
            foreach($size_array as $size_value){
                if($size_value['value'] == $sizes[$i]){
                    $array[] = $size_value['label'];
                }
            }
        }
        return $array;
    }

    /*Get the number of count in template*/
    public function getCheckedTemplateCount($imageId, $productId)
    {
        $count = 0;
        $model = $this->areaFactory;
        $areaCollection = $model->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->addFieldToFilter('product_id', ['eq' => $productId])->addFieldToFilter('template_checked', ['eq' => "checked"]);
        foreach ($areaCollection as $area) {
            ++$count;
        }
        return $count;
    }

    /*Get Un-serialized data*/
    public function getUnserializedData($data)
    {
        $version = $this->mageInfo->getVersion();
        $returnData = '';
        if ($data != null) {
            if ($version >= '2.2.0') {
                $returnData = $this->serializerdata->unserialize($data);
            }
        }
        return $returnData;
    }

    /*Get serialize data*/
    public function getSerializedData($data)
    {
        $version = $this->mageInfo->getVersion();
        $returnData = '';
        if ($data != null) {
            if ($version >= '2.2.0') {
                $returnData = $this->serializerdata->serialize($data);
            }
        }
        return $returnData;
    }

    /*Get jsondecode images information from Gallery.phtml in Adminhtml*/
    public function getDecodeJson($getImagesJson){
        $imagearray = array();
        $deocdeImages=json_decode($getImagesJson);
        foreach($deocdeImages as $decodeimage){
            foreach($decodeimage as $image){
                $imagearray[] = $image;
            }
        }
        return $imagearray;
    }

    public function getFontFolder() {
        $mediaUrl = $this->_storeManager->getStore()->getBaseUrl(UrlInterface::URL_TYPE_MEDIA);
        return $mediaUrl.'fonts/';
    }

    #get Image Media URL
    public function getmediaurlinadmin()
    {
        $path = $this->_storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_MEDIA);
        return $path;
    }


}
