<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Model\Config\Backend;

use Magento\Framework\App\Cache\TypeListInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Config\Value;
use Magento\Framework\Data\Collection\AbstractDb;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Model\Context;
use Magento\Framework\Model\ResourceModel\AbstractResource;
use Magento\Framework\Registry;
use Magento\Store\Model\StoreManagerInterface;
use Milople\Personalizedrich\Helper\Data;

class Lookup extends Value
{
    protected $directoryHelper;


    protected $_storeManager;

    /**
     * @param Context $context
     * @param Registry $registry
     * @param ScopeConfigInterface $config
     * @param TypeListInterface $cacheTypeList
     * @param StoreManagerInterface $storeManager
     * @param \Magento\Directory\Helper\Data $directoryHelper
     * @param AbstractResource $resource
     * @param AbstractDb $resourceCollection
     * @param array $data
     */
    public function __construct(
        Context                        $context,
        Registry                       $registry,
        ScopeConfigInterface           $config,
        TypeListInterface              $cacheTypeList,
        StoreManagerInterface          $storeManager,
        \Magento\Directory\Helper\Data $directoryHelper,
        AbstractResource               $resource = null,
        AbstractDb                     $resourceCollection = null,
        Data                           $data_helper,
        array                          $data = []
    )
    {
        $this->directoryHelper = $directoryHelper;
        $this->helper = $data_helper;
        parent::__construct($context, $registry, $config, $cacheTypeList, $resource, $resourceCollection, $data);
        $this->_storeManager = $storeManager;
    }

    public function beforeSave()
    {
        $value = (string)$this->getValue();
        if (!$this->helper->canRun($this->getValue())) {
            $massage = $this->helper->getAdminMessage();
            throw new LocalizedException(__($massage));
        }
    }
}
