<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2016 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Model\Observer;

use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\ResourceConnection;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Stdlib\DateTime\TimezoneInterface;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Milople\Personalizedrich\Model\Area;
use Milople\Personalizedrich\Model\Template;
use Psr\Log\LoggerInterface;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class OnImageDelete implements ObserverInterface
{

    protected $request;
    protected $resource;

    public function __construct(
        RequestInterface   $request,
        Personalized       $helper,
        TimezoneInterface  $timezone,
        ResourceConnection $resource,
        Area               $areaFactory,
        Template           $templateFactory,
        LoggerInterface    $logger
    )
    {
        $this->_request = $request;
        $this->timezone = $timezone;
        $this->_logger = $logger;
        $this->resource = $resource;
        $this->areaFactory = $areaFactory;
        $this->templateFactory = $templateFactory;
        $this->helper = $helper;
    }

    public function execute(Observer $observer)
    {
        $postdata = $this->_request->getParams();
        if (isset($postdata['product']['media_gallery'])) {
            foreach ($postdata['product']['media_gallery']['images'] as $data) {
                if (isset($data['removed'])) {
                    if ($data['removed'] == 1) {
                        $imageId = $data['value_id'];
                        $areaModel = $this->areaFactory;
                        $areaCollection = $areaModel->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->walk('delete');
                        $templateModel = $this->templateFactory;
                        $templateModel->getCollection()->addFieldToFilter('image_id', ['eq' => $imageId])->walk('delete');
                    }
                }
            }
        }
    }
}
