<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2018 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Plugin;

use Magento\Checkout\Model\DefaultConfigProvider;
use Magento\Framework\Model\AbstractModel;
use Magento\Quote\Model\Quote\Item\Option;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Psr\Log\LoggerInterface;

class ConfigProviderPlugin extends AbstractModel
{
    public function __construct(
        Personalized    $personalized,
        Option          $options,
        LoggerInterface $logger
    )
    {
        $this->personalized = $personalized;
        $this->options = $options;
        $this->logger = $logger;
    }

    public function afterGetConfig(DefaultConfigProvider $subject, array $result)
    {

        $items = $result['totalsData']['items'];
        $quote = $result['quoteItemData'];
        for ($i = 0; $i < count($items); $i++) {

            $itemId = $items[$i]['item_id'];
            $option = $this->options->getCollection()
                ->addFieldToFilter('item_id', ['eq' => $itemId])
                ->addFieldToFilter('code', ['eq' => 'info_buyRequest'])
                ->getFirstItem();
            $unserializeValues = $this->personalized->getUnserializedData($option->getValue());
            if (isset($unserializeValues['image_html'])) {
                $image_html = $this->personalized->getImageMediaUrl($unserializeValues['image_html']);
            } else {
                $image_html = '';
            }
            $items[$i]['image_html'] = $image_html;
        }
        $result['totalsData']['items'] = $items;
        return $result;
    }
}
