<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2018 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Plugin;

use Closure;
use Magento\Checkout\CustomerData\AbstractItem;
use Magento\Quote\Model\Quote\Item;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Psr\Log\LoggerInterface;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class DefaultItem
{
    public function __construct(Personalized $personalized, LoggerInterface $logger)
    {
        $this->personalized = $personalized;
        $this->logger = $logger;
    }

    public function aroundGetItemData(
        AbstractItem $subject,
        Closure      $proceed,
        Item         $item
    )
    {
        $data = $proceed($item);

        $fileName = $item->getBuyRequest()->getImageHtml();
        if ($fileName != '') {
            $fileNames = $this->personalized->getImageMediaUrl($fileName);
            $result['image_html'] = $fileNames;
        } else {
            $result['image_html'] = '';
        }
        $status = $this->personalized->getConfig('personalizedrich/license_status_group/status');
        return array_merge(
            $result,
            $data
        );
    }
}
