<?php
/**
 *
 * Do not edit or add to this file if you wish to upgrade the module to newer
 * versions in the future. If you wish to customize the module for your
 * needs please contact us to https://www.milople.com/contact-us.html
 *
 * @category    Ecommerce
 * @package     Milople_Personlized
 * @copyright   Copyright (c) 2017 Milople Technologies Pvt. Ltd. All Rights Reserved.
 * @url         https://www.milople.com/magento2-extensions/personalized-products-m2.html
 *
 **/

namespace Milople\Personalizedrich\Plugin;

use Magento\Quote\Model\Quote\Item\ToOrderItem;
use Milople\Personalizedrich\Helper\Product\View\Personalized;
use Psr\Log\LoggerInterface;
use \AllowDynamicProperties;
#[AllowDynamicProperties]

class QuoteItemToOrderItemPlugin
{
    public function __construct(
        Personalized    $helper,
        LoggerInterface $logger
    )
    {
        $this->helper = $helper;
        $this->_logger = $logger;
    }

    /* Convert quote item's options to order item's option. */
    public function aroundConvert(ToOrderItem $subject, callable $proceed, $quoteItem, $data)
    {
        /* get order item */
        $orderItem = $proceed($quoteItem, $data);
        if (!$orderItem->getParentItemId()) {
            if ($additionalOptionsQuote = $quoteItem->getOptionByCode('additional_options')) {
                if ($additionalOptionsOrder = $orderItem->getProductOptionByCode('additional_options')) {
                    $additionalOptions = array_merge($additionalOptionsQuote, $additionalOptionsOrder);
                } else {
                    $additionalOptions = $additionalOptionsQuote;
                }
                if (is_array($additionalOptions) && count($additionalOptions) > 0) {
                    $options = $orderItem->getProductOptions();
                    $options['additional_options'] = $this->helper->getUnserializedData($additionalOptions->getValue());
                    $orderItem->setProductOptions($options);
                } elseif (is_object($additionalOptions) && count($additionalOptions->getData()) > 0) {
                    $options = $orderItem->getProductOptions();
                    $options['additional_options'] = $this->helper->getUnserializedData($additionalOptions->getValue());
                    $orderItem->setProductOptions($options);
                }
            }
        }
        return $orderItem;
    }
}
