define([
    'jquery',
    'Magento_Catalog/js/price-utils',
    'underscore',
    'mage/template',
    'jquery/ui'
], function ($, utils, _, mageTemplate) {
    'use strict';
    return function (priceBox) {
        return $.widget('mage.priceBox', priceBox, {
            reloadPrice: function reDrawPrices() {
                var priceFormat = (this.options.priceConfig && this.options.priceConfig.priceFormat) || {},
                    priceTemplate = mageTemplate(this.options.priceTemplate);
                _.each(this.cache.displayPrices, function (price, priceCode) {
                    price.final = _.reduce(price.adjustments, function (memo, amount) {
                        return memo + amount;
                    }, price.amount);

                    price.formatted = utils.formatPrice(price.final, priceFormat);
                    $('[data-price-type="' + priceCode + '"]', this.element).html(priceTemplate({data: price}));

                    /*Custom Code Start*/
                    var pricePerText = 0;
                    var pricePerImage = 0;
                    var textVar = document.getElementById('add_text');
                    if (textVar) {
                        pricePerText = textVar.getAttribute('data-price-per-text');
                    } else {
                        pricePerText = 0;
                    }
                    var imageUploader = document.getElementById('uploadimage');
                    if (imageUploader) {
                        pricePerImage = imageUploader.getAttribute('data-price-per-image');
                    } else {
                        pricePerImage = 0;
                    }
                    if (jQuery('.personalized-container').length) {
                        if (priceCode == 'finalPrice')
                            jQuery('span.price-final_price > span[data-price-type="finalPrice"]').attr('data-price-amount', price.amount);
                        var productPrice = parseFloat(jQuery('span.price-final_price > span[data-price-type="finalPrice"]').attr('data-price-amount'));
                        jQuery('#product_price').val(price.amount);
                        var finalPrice = productPrice + (pricePerText * jQuery('#tObject').val()) + (pricePerImage * jQuery('#iObject').val());
                        var formatedPrice = utils.formatPrice(parseFloat(finalPrice));
                        jQuery('span.price-final_price > span[data-price-type="finalPrice"] > span.price').text(formatedPrice);
                    }
                    /*Custom Code Ends*/

                }, this);
            }

        });
    };
});

